/* Hemant Karkande, 09 January 2018, For Defect Fix - S1375097: MP4 video file support in media annotations. */
UPDATE [dbo].[ALENT_FILEFORMAT] SET [MEDIAPROCESSORREQUIRED]=1
WHERE FILEFORMAT='MP4'
GO

/* Hemant Karkande, 10 January 2018, For Defect Fix - S1345249: CRP:404 Error is received for the Marketing Process Efficiency Analysis Report. */
ALTER PROCEDURE [dbo].[POPULATE_RPT_TMPWFEFFICIENCY] @WORKINGDAYS bigint , @WORKINGHOURS bigint ,@ProjectStartDate_From nvarchar(max), @ProjectStartDate_To nvarchar(max)
   
 AS SET NOCOUNT ON
	
	DECLARE @TASK_ID BIGINT,@TASK_STARTDATE DATETIME ,@TASK_DURATION BIGINT, @MINUTESPERDAY BIGINT, @NOOFDAYSFORDURATION BIGINT,
	@ROUNDEDNOOFDAYS BIGINT, @GENERATEDDUEDATE DATETIME, @TASKDUEDATE DATETIME, @Qry NVARCHAR (500), @ProjectClause nvarchar(max), @BaseQuery1 nvarchar(4000), @BaseQuery2 nvarchar(4000)
	
	SET @MINUTESPERDAY = @WORKINGHOURS * 60

	-- DELETE TABLE IF IT ALREADY EXISTS
	IF EXISTS (SELECT 1 
            FROM INFORMATION_SCHEMA.TABLES 
            WHERE TABLE_TYPE='BASE TABLE' 
            AND TABLE_NAME='RPT_TMPWFEFFICIENCY') 
         DROP TABLE RPT_TMPWFEFFICIENCY
         
	
	-- CREATE TABLE         
	CREATE TABLE [dbo].[RPT_TMPWFEFFICIENCY](
	                        [TASKID] [bigint] NULL,
	                        [TASKSTARTDATE] [datetime] NULL,
	                        [TASKDURATION] [bigint] NULL,
	                        [GENERATEDTASKDUEDATE] [datetime] NULL
                        	
                        ) ON [PRIMARY]
                    
	SET @ProjectClause = ''	
	
	-- prepare JobDateClause
	IF (@ProjectStartDate_From <> '' or @ProjectStartDate_To <> '') BEGIN
		IF (@ProjectStartDate_From <> '' and @ProjectStartDate_To <> '') BEGIN
			SET @ProjectClause  = N' AND PROJECT.STARTDATE BETWEEN '+ '''' + @ProjectStartDate_From + '''' + ' AND '+ '''' + @ProjectStartDate_To + '''';
		END		
		ELSE IF (@ProjectStartDate_From <> '' and @ProjectStartDate_To = '')BEGIN
			SET @ProjectClause  = N' AND PROJECT.STARTDATE >= ' + '''' + @ProjectStartDate_From + '''';
		END
		ELSE IF (@ProjectStartDate_From = '' and @ProjectStartDate_To <> '')BEGIN
			SET @ProjectClause  = N' AND PROJECT.STARTDATE <= ' + '''' + @ProjectStartDate_To + '''';
		END		
	END
					    
	-- INSERT ROWS IN TABLE
	SET @BaseQuery1 = N' INSERT INTO RPT_TMPWFEFFICIENCY
        SELECT WF1.WORKFLOWPROCESSID,WF1.STARTDATE,WFPROCINFO.DURATION, NULL
        FROM ALENT_WORKFLOWPROCESS WF1
        INNER JOIN ALOM_ASSOENTITYFACET A1
        ON A1.ENTITYID = WF1.WORKFLOWPROCESSID AND A1.RELATIONSHIPTYPEID=109574871933848 --PROCESS_INFORMATION
        INNER JOIN ALFCT_WORKFLOWPROCESSINFO WFPROCINFO
        ON A1.FACETID = WFPROCINFO.WORKFLOWPROCESSINFOID 
        INNER JOIN ALOM_ASSOENTITYFACET A2
        ON A2.ENTITYID = WF1.WORKFLOWPROCESSID AND A2.RELATIONSHIPTYPEID = 154951847894 --WORKFLOWPROCESS_WORKFLOWINFORMATION
        INNER JOIN ALFCT_WORKFLOWINFORMATION WFINFO
        ON A2.FACETID = WFINFO.WORKFLOWINFORMATIONID AND WFINFO.WORKFLOWCATEGORY = ''TASK'' AND 
        ( (WFINFO.WORKFLOWSUBCATEGORY = ''ASSIGNMENT'') OR (WFINFO.WORKFLOWSUBCATEGORY = ''ROUTE'' AND WFINFO.ROUTEMETHOD != ''SIMULTANEOUS'')
        OR (WFINFO.WORKFLOWSUBCATEGORY = ''WEBPROCESS'' AND WFINFO.ROUTEMETHOD != ''SIMULTANEOUS'')  OR  (WFINFO.WORKFLOWSUBCATEGORY = ''MULTI-FILEROUTE'' AND WFINFO.ROUTEMETHOD != ''SIMULTANEOUS''))
        INNER JOIN ALOM_ASSEMBLY ASS1 ON WF1.WORKFLOWPROCESSID = ASS1.CONTAINSID AND ASS1.RELATIONSHIPTYPEID = 104837164729839  --DELIVERABLE_TASK
		INNER JOIN ALENT_WORKFLOWPROCESS DELIVERABLE ON ASS1.CONTAINERID = DELIVERABLE.WORKFLOWPROCESSID
		INNER JOIN ALOM_ASSEMBLY ASS2 ON DELIVERABLE.WORKFLOWPROCESSID = ASS2.CONTAINSID AND ASS2.RELATIONSHIPTYPEID = 235798844984010  --PROJECT_DELIVERABLE
		INNER JOIN ALENT_WORKFLOWPROCESS PROJECT ON ASS2.CONTAINERID = PROJECT.WORKFLOWPROCESSID '

EXEC (@BaseQuery1 + ' '+@ProjectClause)

SET @BaseQuery1 =''

SET @BaseQuery1 = N' INSERT INTO RPT_TMPWFEFFICIENCY        
			SELECT WF1.WORKFLOWPROCESSID,WF1.STARTDATE, MAX(ACTINFO.DURATION), NULL
			FROM ALENT_WORKFLOWPROCESS WF1
			INNER JOIN ALOM_ASSOENTITYFACET ASSO1
			ON ASSO1.ENTITYID = WF1.WORKFLOWPROCESSID AND RELATIONSHIPTYPEID=154951847894 --WORKFLOWPROCESS_WORKFLOWINFORMATION
			INNER JOIN ALFCT_WORKFLOWINFORMATION WFINFO1
			ON ASSO1.FACETID = WFINFO1.WORKFLOWINFORMATIONID AND ( (WFINFO1.WORKFLOWSUBCATEGORY = ''GATHERINFORMATION'') OR
			(WFINFO1.WORKFLOWSUBCATEGORY = ''DISCUSSION'') OR (WFINFO1.WORKFLOWSUBCATEGORY = ''TRACKING'') OR 
			(WFINFO1.WORKFLOWSUBCATEGORY = ''ROUTE'' AND WFINFO1.ROUTEMETHOD = ''SIMULTANEOUS'') OR 
			(WFINFO1.WORKFLOWSUBCATEGORY = ''MULTI-FILEROUTE'' AND WFINFO1.ROUTEMETHOD = ''SIMULTANEOUS'') OR
			(WFINFO1.WORKFLOWSUBCATEGORY = ''WEBPROCESS'' AND WFINFO1.ROUTEMETHOD = ''SIMULTANEOUS'') )
			INNER JOIN ALOM_ASSEMBLY ASSEM1
			ON WF1.WORKFLOWPROCESSID = ASSEM1.CONTAINERID AND ASSEM1.RELATIONSHIPTYPEID=154010190849386 --PROCESS_ACTIVITY
			INNER JOIN ALENT_ACTIVITY ACT1
			ON ASSEM1.CONTAINSID=ACT1.ACTIVITYID AND STARTACTIVITY=''FALSE'' AND ENDACTIVITY=''FALSE''
			INNER JOIN ALOM_ASSOENTITYFACET ASSO2
			ON ASSO2.ENTITYID = ACT1.ACTIVITYID AND ASSO2.RELATIONSHIPTYPEID = 79760151954703 --ACTIVITY_INFORMATION
			INNER JOIN ALFCT_ACTIVITYINFORMATION ACTINFO
			ON ASSO2.FACETID = ACTINFO.ACTIVITYINFORMATIONID
			INNER JOIN ALOM_ASSEMBLY ASS1 ON WF1.WORKFLOWPROCESSID = ASS1.CONTAINSID AND ASS1.RELATIONSHIPTYPEID = 104837164729839  --DELIVERABLE_TASK
			INNER JOIN ALENT_WORKFLOWPROCESS DELIVERABLE ON ASS1.CONTAINERID = DELIVERABLE.WORKFLOWPROCESSID
			INNER JOIN ALOM_ASSEMBLY ASS2 ON DELIVERABLE.WORKFLOWPROCESSID = ASS2.CONTAINSID AND ASS2.RELATIONSHIPTYPEID = 235798844984010  --PROJECT_DELIVERABLE
			INNER JOIN ALENT_WORKFLOWPROCESS PROJECT ON ASS2.CONTAINERID = PROJECT.WORKFLOWPROCESSID'
			 
			SET @BaseQuery2 =N' GROUP BY WF1.WORKFLOWPROCESSID, WF1.STARTDATE '

EXEC (@BaseQuery1 + ' '+@ProjectClause+' '+@BaseQuery2)

	-- CODE TO POPULATE GENERATED DUEDATE
	DECLARE C1 CURSOR FOR
	SELECT TASKID,TASKSTARTDATE, TASKDURATION FROM RPT_TMPWFEFFICIENCY
	
	OPEN C1
	FETCH NEXT FROM C1 INTO @TASK_ID, @TASK_STARTDATE, @TASK_DURATION
	WHILE @@FETCH_STATUS = 0
	BEGIN
		
		IF @TASK_DURATION > 0
		BEGIN
			SET @NOOFDAYSFORDURATION = @TASK_DURATION
		END
		ELSE
		BEGIN
			SET @NOOFDAYSFORDURATION = 0
		END
		
		SET @GENERATEDDUEDATE = @TASK_STARTDATE
		
		IF @WORKINGDAYS = 5
		BEGIN
			WHILE @NOOFDAYSFORDURATION > 1
			BEGIN
				SET @GENERATEDDUEDATE = DATEADD(DD,1,@GENERATEDDUEDATE)
				
				IF DATEPART(dw, @GENERATEDDUEDATE) != 1 AND DATEPART(dw, @GENERATEDDUEDATE) != 7
				BEGIN
					SET @NOOFDAYSFORDURATION = @NOOFDAYSFORDURATION - 1
				END
			END
		END
		ELSE
		BEGIN
			IF @WORKINGDAYS = 6
			BEGIN
				WHILE @NOOFDAYSFORDURATION > 1
				BEGIN
					SET @GENERATEDDUEDATE = DATEADD(DD,1,@GENERATEDDUEDATE)
					
					IF DATEPART(dw, @GENERATEDDUEDATE) != 1
					BEGIN
							SET @NOOFDAYSFORDURATION = @NOOFDAYSFORDURATION - 1
					END
				END
			END
		END
		
		SET @TASKDUEDATE = @GENERATEDDUEDATE
		
		-- PREPARE & EXECUTE QUERY
		SET @Qry = 'UPDATE RPT_TMPWFEFFICIENCY SET GENERATEDTASKDUEDATE = ''' + CONVERT(NVARCHAR(100), @TASKDUEDATE,21) + ''' WHERE TASKID = ' + CAST(@TASK_ID AS NVARCHAR(16))
		Exec(@Qry)
		
		FETCH NEXT FROM C1 INTO @TASK_ID, @TASK_STARTDATE, @TASK_DURATION
	END
CLOSE C1
DEALLOCATE C1

GO

--For Defect Fix - S1363865: Recovery Sheet Report does not show the correct data in MOM 6.5 */

ALTER PROCEDURE [dbo].[SP_RPT_RECOVERY_SHEET]  @MktActivityID nvarchar(100), @CostCatID nvarchar(100), @BUIDList nvarchar(1000), @FISCAL_YEAR nvarchar(4),@FiscalMonthPreviousYear_Clause nvarchar(10)   
AS 
	Declare @andclause nvarchar(4000)
	Declare @vch1 nvarchar(4000),@DURATION_TYPE NVARCHAR(10),@MA_PATH_SEPARATOR NVARCHAR(100),@F_MONTH NVARCHAR(2),
	@FY_STARTDATE DATETIME,@FY_ENDDATE DATETIME,@paidondate_clause nvarchar(2000),@final_query NVARCHAR(MAX),@ERRORID int

	--@MktActivityID is a Mandatory parameter
	SET @andclause = ' WHERE (ALENT_MARKETINGACTIVITY.MARKETINGACTIVITYID = ' + @MktActivityID +')'
	
	IF(@CostCatID <> '') BEGIN
		SET @andclause = @andclause + ' AND (ALENT_COSTCATEGORY_ALIAS.COSTCATEGORYID IN ' + @CostCatID + ')'
	END
	IF(@BUIDList <> '') BEGIN
		SET @andclause = @andclause + ' AND (ALENT_BUSINESSUNIT_ALIAS.BUSINESSUNITID IN ' + @BUIDList + ')'
	END
	IF(@FISCAL_YEAR <> '') BEGIN
		SET @andclause = @andclause + '  AND (ALENT_PLAN_ALIAS.FISCALYEAR = ' + @FISCAL_YEAR + ')'
	END
	
	EXEC @errorid = Verify_Input_Where_Clause @andclause

	IF EXISTS (SELECT 1 FROM ALENT_FORECASTCONFIGURATION WHERE FISCALYEAR = CAST(@FISCAL_YEAR AS INT) AND DURATIONTYPE = 'CALENDAR')
	BEGIN
		SELECT @F_MONTH = CASE WHEN LEN(CONFIGVALUE) = 1 THEN '0'+CONFIGVALUE ELSE CONFIGVALUE END 
		FROM ALENT_CONFIGURATION WHERE CONFIGNAME = 'FISCALMONTH'

		IF @FiscalMonthPreviousYear_Clause = 'NO'
			SELECT  @FY_STARTDATE = CAST(@FISCAL_YEAR+'-'+@F_MONTH+'-'+'01 00:00:00' AS DATETIME),
			@FY_ENDDATE = DATEADD(MM,12,CAST(@FISCAL_YEAR+'-'+@F_MONTH+'-'+'01 23:59:59' AS DATETIME))-1
		ELSE
			SELECT  @FY_STARTDATE = DATEADD(YY,-1,CAST(@FISCAL_YEAR+'-'+@F_MONTH+'-'+'01 00:00:00' AS DATETIME)),
			@FY_ENDDATE = CAST(@FISCAL_YEAR+'-'+@F_MONTH+'-'+'01 23:59:59' AS DATETIME)-1
		
	END
	ELSE
	BEGIN
		SELECT @FY_STARTDATE = MIN(STARTDATE),@FY_ENDDATE = MAX(ENDDATE)
		FROM
		ALENT_FORECASTCONFIGURATION INNER JOIN ALOM_ASSOENTITYFACET
		ON RELATIONSHIPTYPEID = 244610989931011 AND ENTITYID = FORECASTCONFIGID
		AND FISCALYEAR = CAST(@FISCAL_YEAR AS INT)
		INNER JOIN ALFCT_FORECASTPERIODS
		ON FACETID = FORECASTPERIODSID
	END
	
	
	
	SELECT @DURATION_TYPE = N''
		
	IF EXISTS (SELECT 1 FROM ALENT_FORECASTCONFIGURATION WHERE FISCALYEAR = @FISCAL_YEAR)
	BEGIN
		SELECT @DURATION_TYPE = ''''+DURATIONTYPE+'''' FROM ALENT_FORECASTCONFIGURATION WHERE FISCALYEAR = @FISCAL_YEAR
	END
	ELSE
	BEGIN
		SELECT @DURATION_TYPE = N''''+'CALENDAR'+''''
	END
	
	IF EXISTS (SELECT 1 FROM ALENT_CONFIGURATION WHERE CONFIGNAME = 'ACTIVITYPATHSEPARATOR')
	BEGIN
		SELECT @MA_PATH_SEPARATOR = CONFIGVALUE FROM ALENT_CONFIGURATION WHERE CONFIGNAME = 'ACTIVITYPATHSEPARATOR'
	END
	ELSE
	BEGIN
		SELECT @MA_PATH_SEPARATOR = '>>'
	END
	
	select @vch1=N'

	DECLARE @TEOBJECT TABLE (FILTEREDOBJID NUMERIC,ACTIVITYID NUMERIC)  

	/*get invoice1*/
	DECLARE @INVOICE1 TABLE (FILTEREDOBJID NUMERIC,ACTIVITYID NUMERIC) 
	INSERT INTO @INVOICE1 (FILTEREDOBJID,ACTIVITYID) 
	SELECT TE.INVOICEID,ALENT_MARKETINGACTIVITY.MARKETINGACTIVITYID
	FROM ALENT_MARKETINGACTIVITY/*ALENT_INVOICE1 */
	left outer JOIN ALOM_ASSEMBLY ASSEMBLY1 ON ALENT_MARKETINGACTIVITY.MARKETINGACTIVITYID = ASSEMBLY1.CONTAINERID 
		AND ASSEMBLY1.RELATIONSHIPTYPEID = 258169431586434
	left outer JOIN ALENT_INVOICE TE ON ASSEMBLY1.CONTAINSID= TE.INVOICEID  
	left outer JOIN ALOM_ASSEMBLY ASSEMBLY2 ON  ASSEMBLY2.CONTAINERID = TE.INVOICEID
	left outer JOIN ALENT_VENDORS  ALENT_VENDORS_ALIAS ON ASSEMBLY2.CONTAINSID = ALENT_VENDORS_ALIAS.VENDORSID
	left outer join alom_assoentityfacet asf on asf.entityid=TE.INVOICEID
	left outer join alfct_lineitems alfct_lineitem_alias on asf.facetid=alfct_lineitem_alias.LINEITEMSID
	left outer join alom_assoentityfacet asf1 on asf1.facetid=alfct_lineitem_alias.LINEITEMSID
	left outer join alent_costcategory alent_costcategory_alias on asf1.entityid=alent_costcategory_alias.costcategoryid 
	left outer join alom_assembly assembly4 on assembly4.containsid=ALENT_MARKETINGACTIVITY.MARKETINGACTIVITYID and (assembly4.relationshiptypeid=38934607864244 or assembly4.relationshiptypeid=198303327217807)
	left outer join alent_plan alent_plan_alias on assembly4.containerid=alent_plan_alias.planid
	left outer join alom_assembly assembly5 on assembly5.containerid=alent_plan_alias.planid and assembly5.relationshiptypeid=141014623932230
	left outer join alent_businessunit alent_businessunit_alias on assembly5.containsid= alent_businessunit_alias.businessunitid '

	DECLARE @VCHandclause1 NVARCHAR(4000)
	SET @VCHandclause1 = (SELECT @andclause)

	SELECT @paidondate_clause = N' AND (TE.INVOICEPAIDON IS NULL OR (TE.INVOICEPAIDON BETWEEN '+''''+CAST(@FY_STARTDATE AS NVARCHAR(30))+''''+' AND '+''''+CAST(@FY_ENDDATE AS NVARCHAR(30))+''''+'))  '

	/*get invoice2*/
	Declare @vch2 nvarchar(4000)
	select @vch2=N'
	DECLARE @INVOICE2 TABLE (FILTEREDOBJID NUMERIC,ACTIVITYID NUMERIC) 
	INSERT INTO @INVOICE2 (FILTEREDOBJID,ACTIVITYID) 
	SELECT TE.INVOICEID, ALENT_MARKETINGACTIVITY.MARKETINGACTIVITYID
	FROM ALENT_MARKETINGACTIVITY/*ALENT_INVOICE2 */
	left outer JOIN ALOM_ASSEMBLY ASSEMBLY2 ON ALENT_MARKETINGACTIVITY.MARKETINGACTIVITYID= ASSEMBLY2.CONTAINERID
		AND ASSEMBLY2.RELATIONSHIPTYPEID = 54043127184334
	left outer JOIN ALENT_INVOICE TE ON ASSEMBLY2.CONTAINSID=TE.INVOICEID 
	left outer JOIN ALOM_ASSEMBLY ASSEMBLY1 ON  ASSEMBLY1.CONTAINERID = TE.INVOICEID
	left outer JOIN ALENT_VENDORS  ALENT_VENDORS_ALIAS ON ASSEMBLY1.CONTAINSID = ALENT_VENDORS_ALIAS.VENDORSID
	left outer join alom_assoentityfacet asf on asf.entityid=TE.INVOICEID
	left outer join alfct_lineitems alfct_lineitem_alias on asf.facetid=alfct_lineitem_alias.LINEITEMSID
	left outer join alom_assoentityfacet asf1 on asf1.facetid=alfct_lineitem_alias.LINEITEMSID
	left outer join alent_costcategory alent_costcategory_alias on asf1.entityid=alent_costcategory_alias.costcategoryid 
	left outer join alom_assembly assembly4 on assembly4.containsid=ALENT_MARKETINGACTIVITY.MARKETINGACTIVITYID and (assembly4.relationshiptypeid=38934607864244 or assembly4.relationshiptypeid=198303327217807)
	left outer join alent_plan alent_plan_alias on assembly4.containerid=alent_plan_alias.planid
	left outer join alom_assembly assembly5 on assembly5.containerid=alent_plan_alias.planid and assembly5.relationshiptypeid=141014623932230
	left outer join alent_businessunit alent_businessunit_alias on assembly5.containsid= alent_businessunit_alias.businessunitid  '


	DECLARE @VCHandclause2 NVARCHAR(max)
	SET @VCHandclause2 = (SELECT @andclause)

	/*get invoice*/
	Declare @vch3 nvarchar(max)
	select @vch3=N'
	DECLARE @INVOICE TABLE (FILTEREDOBJID NUMERIC,ACTIVITYID NUMERIC) 
	INSERT INTO @INVOICE (FILTEREDOBJID,ACTIVITYID) 
	SELECT FILTEREDOBJID ,ACTIVITYID
	FROM @INVOICE1 
	UNION 
	SELECT FILTEREDOBJID ,ACTIVITYID
	FROM @INVOICE2  
	 
	INSERT INTO @TEOBJECT (FILTEREDOBJID,ACTIVITYID) 
	SELECT DISTINCT  INVOICE.FILTEREDOBJID ,INVOICE.ACTIVITYID
	FROM @INVOICE INVOICE 
	LEFT OUTER JOIN ALENT_INVOICE TE ON INVOICE.FILTEREDOBJID = TE.INVOICEID  
	
	/*GET VENDORS*/
	DECLARE @REVENDOR TABLE (VEN_ID NUMERIC, FILTEREDOBJID NUMERIC ) 
	INSERT INTO @REVENDOR (VEN_ID,FILTEREDOBJID) 
	SELECT CONTAINSID, TEOBJECT_ALIAS.FILTEREDOBJID 
	FROM ALOM_ASSEMBLY ASSEMBLY  
	INNER JOIN @TEOBJECT TEOBJECT_ALIAS ON ASSEMBLY.CONTAINERID = TEOBJECT_ALIAS.FILTEREDOBJID AND ASSEMBLY.RELATIONSHIPTYPEID = 120841619528864 

	/*GET ACTIVITY1*/
	DECLARE @REACTIVITY1 TABLE (ACTIVITY1_ID NUMERIC, FILTEREDOBJID NUMERIC ) 
	INSERT INTO @REACTIVITY1 (ACTIVITY1_ID,FILTEREDOBJID  ) 
	SELECT TEOBJECT_ALIAS.ACTIVITYID, ASSEMBLY.CONTAINSID 
	FROM @TEOBJECT TEOBJECT_ALIAS 
	LEFT OUTER JOIN ALOM_ASSEMBLY ASSEMBLY ON TEOBJECT_ALIAS.ACTIVITYID =ASSEMBLY.CONTAINERID
	AND ASSEMBLY.RELATIONSHIPTYPEID = 258169431586434 
	'
	Declare @vch4 nvarchar(max)
	select @vch4=N'
	/*GET  PLAN1*/
	DECLARE @REPLAN1 TABLE (PLAN1_ID NUMERIC, ACTIVITY1_ID NUMERIC, FILTEREDOBJID NUMERIC ) 
	INSERT INTO @REPLAN1 (PLAN1_ID,ACTIVITY1_ID , FILTEREDOBJID  ) 
	SELECT CONTAINERID, ACTIVITY1_ALIAS.ACTIVITY1_ID , ACTIVITY1_ALIAS.FILTEREDOBJID 
	FROM ALOM_ASSEMBLY ASSEMBLY  
	INNER JOIN @REACTIVITY1 ACTIVITY1_ALIAS ON ASSEMBLY.CONTAINSID = ACTIVITY1_ALIAS.ACTIVITY1_ID AND ASSEMBLY.RELATIONSHIPTYPEID = 38934607864244 

	/*GET BUSINESSUNIT_1*/
	DECLARE @REBUSINESSUNIT_1 TABLE (BUSINESSUNIT_1_ID NUMERIC, PLAN1_ID NUMERIC, ACTIVITY1_ID NUMERIC, FILTEREDOBJID NUMERIC ) 
	INSERT INTO @REBUSINESSUNIT_1 (BUSINESSUNIT_1_ID,PLAN1_ID , ACTIVITY1_ID , FILTEREDOBJID  ) 
	SELECT CONTAINSID, REPLAN1_ALIAS.PLAN1_ID , REPLAN1_ALIAS.ACTIVITY1_ID , REPLAN1_ALIAS.FILTEREDOBJID 
	FROM ALOM_ASSEMBLY ASSEMBLY  
	INNER JOIN @REPLAN1 REPLAN1_ALIAS ON ASSEMBLY.CONTAINERID = REPLAN1_ALIAS.PLAN1_ID AND ASSEMBLY.RELATIONSHIPTYPEID = 141014623932230 

	/* GET PLAN2*/
	DECLARE @REPLAN2 TABLE (PLAN2_ID NUMERIC, ACTIVITY1_ID NUMERIC, FILTEREDOBJID NUMERIC ) 
	INSERT INTO @REPLAN2 (PLAN2_ID,ACTIVITY1_ID , FILTEREDOBJID  ) 
	SELECT CONTAINERID, ACTIVITY1_ALIAS.ACTIVITY1_ID , ACTIVITY1_ALIAS.FILTEREDOBJID 
	FROM ALOM_ASSEMBLY ASSEMBLY  
	INNER JOIN @REACTIVITY1 ACTIVITY1_ALIAS ON ASSEMBLY.CONTAINSID = ACTIVITY1_ALIAS.ACTIVITY1_ID AND ASSEMBLY.RELATIONSHIPTYPEID = 198303327217807 

	/*GET BUSINESSUNIT_2*/
	DECLARE @REBUSINESSUNIT_2 TABLE (BUSINESSUNIT_2_ID NUMERIC, PLAN2_ID NUMERIC, ACTIVITY1_ID NUMERIC, FILTEREDOBJID NUMERIC ) 
	INSERT INTO @REBUSINESSUNIT_2 (BUSINESSUNIT_2_ID,PLAN2_ID , ACTIVITY1_ID , FILTEREDOBJID  ) 
	SELECT CONTAINSID, REPLAN_2_ALIAS.PLAN2_ID , REPLAN_2_ALIAS.ACTIVITY1_ID , REPLAN_2_ALIAS.FILTEREDOBJID 
	FROM ALOM_ASSEMBLY ASSEMBLY  
	INNER JOIN @REPLAN2 REPLAN_2_ALIAS ON ASSEMBLY.CONTAINERID = REPLAN_2_ALIAS.PLAN2_ID AND ASSEMBLY.RELATIONSHIPTYPEID = 141014623932230 

	/*GET ACTIVITY2*/
	DECLARE @REACTIVITY2 TABLE (ACTIVITY2_ID NUMERIC, FILTEREDOBJID NUMERIC ) 
	INSERT INTO @REACTIVITY2 (ACTIVITY2_ID,FILTEREDOBJID  ) 
	SELECT TEOBJECT_ALIAS.ACTIVITYID, ASSEMBLY.CONTAINSID 
	FROM @TEOBJECT TEOBJECT_ALIAS
	left outer JOIN ALOM_ASSEMBLY  ASSEMBLY ON ASSEMBLY.CONTAINERID = TEOBJECT_ALIAS.ACTIVITYID
	AND ASSEMBLY.RELATIONSHIPTYPEID = 54043127184334 
	'

	Declare @vch5 nvarchar(max)
	select @vch5=N'

	/*GET PLAN3*/
	DECLARE @REPLAN3 TABLE (PLAN3_ID NUMERIC, ACTIVITY2_ID NUMERIC, FILTEREDOBJID NUMERIC ) 
	INSERT INTO @REPLAN3 (PLAN3_ID,ACTIVITY2_ID , FILTEREDOBJID  ) 
	SELECT CONTAINERID, ACTIVITY2_ALIAS.ACTIVITY2_ID , ACTIVITY2_ALIAS.FILTEREDOBJID 
	FROM ALOM_ASSEMBLY ASSEMBLY  
	INNER JOIN @REACTIVITY2 ACTIVITY2_ALIAS ON ASSEMBLY.CONTAINSID = ACTIVITY2_ALIAS.ACTIVITY2_ID AND ASSEMBLY.RELATIONSHIPTYPEID = 38934607864244 
	
	/*GET BUSINESSUNIT_3*/
	DECLARE @REBUSINESSUNIT_3 TABLE (BUSINESSUNIT_3_ID NUMERIC, PLAN3_ID NUMERIC, ACTIVITY2_ID NUMERIC, FILTEREDOBJID NUMERIC ) 
	INSERT INTO @REBUSINESSUNIT_3 (BUSINESSUNIT_3_ID,PLAN3_ID , ACTIVITY2_ID , FILTEREDOBJID  ) 
	SELECT CONTAINSID, REPLAN_3_ALIAS.PLAN3_ID , REPLAN_3_ALIAS.ACTIVITY2_ID , REPLAN_3_ALIAS.FILTEREDOBJID 
	FROM ALOM_ASSEMBLY ASSEMBLY  
	INNER JOIN @REPLAN3 REPLAN_3_ALIAS ON ASSEMBLY.CONTAINERID = REPLAN_3_ALIAS.PLAN3_ID AND ASSEMBLY.RELATIONSHIPTYPEID = 141014623932230 

	/*GET PLAN4*/
	DECLARE @REPLAN4 TABLE (PLAN4_ID NUMERIC, ACTIVITY2_ID NUMERIC, FILTEREDOBJID NUMERIC ) 
	INSERT INTO @REPLAN4 (PLAN4_ID,ACTIVITY2_ID , FILTEREDOBJID  ) 
	SELECT CONTAINERID, ACTIVITY2_ALIAS.ACTIVITY2_ID , ACTIVITY2_ALIAS.FILTEREDOBJID 
	FROM ALOM_ASSEMBLY ASSEMBLY  
	INNER JOIN @REACTIVITY2 ACTIVITY2_ALIAS ON ASSEMBLY.CONTAINSID = ACTIVITY2_ALIAS.ACTIVITY2_ID AND ASSEMBLY.RELATIONSHIPTYPEID = 198303327217807 

	/*get  BUSINESSUNIT_4*/
	DECLARE @REBUSINESSUNIT_4 TABLE (BUSINESSUNIT_4_ID NUMERIC, PLAN4_ID NUMERIC, ACTIVITY2_ID NUMERIC, FILTEREDOBJID NUMERIC ) 
	INSERT INTO @REBUSINESSUNIT_4 (BUSINESSUNIT_4_ID,PLAN4_ID , ACTIVITY2_ID , FILTEREDOBJID  ) 
	SELECT CONTAINSID, REPLAN_4_ALIAS.PLAN4_ID , REPLAN_4_ALIAS.ACTIVITY2_ID , REPLAN_4_ALIAS.FILTEREDOBJID 
	FROM ALOM_ASSEMBLY ASSEMBLY  
	INNER JOIN @REPLAN4 REPLAN_4_ALIAS ON ASSEMBLY.CONTAINERID = REPLAN_4_ALIAS.PLAN4_ID AND ASSEMBLY.RELATIONSHIPTYPEID = 141014623932230 
	'

	/*get lineitems*/
	Declare @vch6 nvarchar(max)
	select @vch6=N'
	DECLARE @RFLINEITEM TABLE (lineitem_id NUMERIC, FILTEREDOBJID NUMERIC ) 
	INSERT INTO @RFLINEITEM (lineitem_id , FILTEREDOBJID  ) 
	SELECT FACETID, TEOBJECT_ALIAS.FILTEREDOBJID 
	FROM ALOM_ASSOENTITYFACET ASSOENTFCT  
	INNER JOIN @TEOBJECT TEOBJECT_ALIAS ON ASSOENTFCT.ENTITYID = TEOBJECT_ALIAS.FILTEREDOBJID 
	inner join alfct_lineitems on ASSOENTFCT.facetid=alfct_lineitems.lineitemsid
	WHERE ASSOENTFCT.ENTITYTYPEID = 177961482715500 AND  ASSOENTFCT.FACETTYPEID = 214754957379023   

	/*GET PLAN*/
	DECLARE @REPLAN TABLE (PLAN_ID NUMERIC,FILTEREDOBJID NUMERIC)
	INSERT INTO @REPLAN (PLAN_ID,FILTEREDOBJID)
	SELECT PLAN4_ID,FILTEREDOBJID
	FROM @REPLAN4
	UNION
	SELECT PLAN3_ID,FILTEREDOBJID
	FROM @REPLAN3
	UNION
	SELECT PLAN2_ID,FILTEREDOBJID
	FROM @REPLAN2
	UNION
	SELECT PLAN1_ID,FILTEREDOBJID
	FROM @REPLAN1

	/*GET BUSINESSUNIT*/
	DECLARE @REBUSINESSUNIT TABLE(BUSINESSUNIT_ID NUMERIC,FILTEREDOBJID NUMERIC,ACTIVITYID NUMERIC)
	INSERT INTO @REBUSINESSUNIT (BUSINESSUNIT_ID,FILTEREDOBJID,ACTIVITYID)
	SELECT BUSINESSUNIT_4_ID,FILTEREDOBJID,ACTIVITY2_ID
	FROM @REBUSINESSUNIT_4
	UNION
	SELECT BUSINESSUNIT_3_ID,FILTEREDOBJID,ACTIVITY2_ID
	FROM @REBUSINESSUNIT_3
	UNION
	SELECT BUSINESSUNIT_2_ID,FILTEREDOBJID,ACTIVITY1_ID
	FROM @REBUSINESSUNIT_2
	UNION
	SELECT BUSINESSUNIT_1_ID,FILTEREDOBJID,ACTIVITY1_ID
	FROM @REBUSINESSUNIT_1
	'


	Declare @vch7 nvarchar(max)
	select @vch7=N'
	/*GET ACTIVITY*/
	DECLARE @REACTIVITY TABLE(ACTIVITY_ID NUMERIC,FILTEREDOBJID NUMERIC)
	INSERT INTO @REACTIVITY (ACTIVITY_ID,FILTEREDOBJID)
	SELECT ACTIVITY1_ID,FILTEREDOBJID
	FROM @REACTIVITY1
	UNION
	SELECT ACTIVITY2_ID,FILTEREDOBJID
	FROM @REACTIVITY2
	
	/*get budgetallocation*/
	DECLARE @RFBUDGETALLOCATION TABLE(BUDALLOC_ID NUMERIC,FILTEREDOBJID NUMERIC)
	INSERT INTO @RFBUDGETALLOCATION (BUDALLOC_ID,FILTEREDOBJID)
	SELECT FACETID,REACTIVITY_ALIAS.FILTEREDOBJID
	FROM ALOM_ASSOENTITYFACET ASF
	INNER JOIN @REACTIVITY REACTIVITY_ALIAS ON ASF.ENTITYID=REACTIVITY_ALIAS.ACTIVITY_ID
	WHERE ASF.FACETTYPEID=119834708430096 AND ASF.ENTITYTYPEID=230396323080180

	/*get COSTCATEGORY*/
	DECLARE @RECOSTCATEGORY TABLE(costcat_id NUMERIC, lineitem_id NUMERIC , FILTEREDOBJID NUMERIC)
	INSERT INTO @RECOSTCATEGORY (costcat_id, lineitem_id , FILTEREDOBJID)
	SELECT entityid, RFLINEITEM_ALIAS.lineitem_id ,RFLINEITEM_ALIAS.FILTEREDOBJID
	FROM ALOM_ASSOENTITYFACET ASF10
	INNER JOIN @RFLINEITEM RFLINEITEM_ALIAS ON ASF10.FACETID=RFLINEITEM_ALIAS.lineitem_id
	inner join alent_costcategory on alent_costcategory.costcategoryid = ASF10.entityid
	where ASF10.FACETTYPEID = 214754957379023 and ASF10.ENTITYTYPEID=196417095697162
	'

	Declare @vch8 nvarchar(max)
	select @vch8=N'
	SELECT distinct
	invoice.invoiceid,
	invoice.invoicenumber,
	invoice.invoicedueon,
	invoice.INVOICEPAIDON,
	invoice.invoicereceivedon,
	plan_alias.fiscalyear,
	lineitems.lineitemsid,
	CAST(lineitems.itemamount_a AS FLOAT) AS "itemamount_a",
	costcat.costcategoryid,
	costcat.name costcategory_name,
	bu.name bu_name,
	activity.marketingactivityid,
	activity.name activity_name,
	activity.activitynumber,
	CASE WHEN CHARINDEX(''$ALP$'',activity.ACTIVITYPATH) > 0 THEN REPLACE(activity.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+') ELSE  activity.ACTIVITYPATH END AS ACTIVITYPATH,
	vendor.name vendorname,
	null as costcenter_name,
	CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INVOICE.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INVOICE.INVOICEPAIDON) ELSE NULL END ELSE NULL END AS QUARTER
	from @REACTIVITY reactivity
	inner join alent_marketingactivity activity on activity.marketingactivityid = reactivity.activity_id
	left outer join @TEOBJECT TEInvoice on TEInvoice.activityid = reactivity.activity_id
	left outer join alent_invoice invoice on TEInvoice.FILTEREDOBJID=invoice.invoiceid
	left outer join @REPLAN REPLAN on REPLAN.FILTEREDOBJID=TEInvoice.FILTEREDOBJID
	left outer join alent_plan plan_alias on REPLAN.PLAN_ID=plan_alias.planid
	LEFT OUTER JOIN @RFBUDGETALLOCATION RFBUDALLOC ON RFBUDALLOC.FILTEREDOBJID=TEInvoice.FILTEREDOBJID  
	LEFT OUTER JOIN ALFCT_BUDGETALLOCATION BUDALLOC ON RFBUDALLOC.BUDALLOC_ID=BUDALLOC.BUDGETALLOCATIONID
	left outer join (select DISTINCT ACTIVITYID,BUSINESSUNIT_ID FROM @REBUSINESSUNIT) rebu on rebu.ACTIVITYID=TEInvoice.ACTIVITYID
	left outer join alent_businessunit bu on rebu.BUSINESSUNIT_ID=bu.businessunitid
	left outer join @RFLINEITEM rflineitem on rflineitem.FILTEREDOBJID=TEInvoice.FILTEREDOBJID
	left outer join alfct_lineitems  lineitems on rflineitem.lineitem_id=lineitems.lineitemsid
	left outer join @REVENDOR revendor on revendor.FILTEREDOBJID=TEInvoice.FILTEREDOBJID
	left outer join alent_vendors vendor on revendor.VEN_ID=vendor.vendorsid
	left outer join @RECOSTCATEGORY recostcat on recostcat.lineitem_id = rflineitem.lineitem_id
	left outer join alent_costcategory costcat on recostcat.costcat_id=costcat.costcategoryid
	'

	Declare @vch9 nvarchar(max)
	select @vch9 = N'
	union SELECT distinct
	invoice.invoiceid,
	invoice.invoicenumber,
	invoice.invoicedueon,
	invoice.INVOICEPAIDON,
	invoice.invoicereceivedon,
	plan_alias.fiscalyear,
	null as lineitemsid,
	null as itemamount_a,
	costcat.costcategoryid,
	costcat.name costcategory_name,
	bu.name bu_name,
	activity.marketingactivityid,
	activity.name activity_name,
	activity.activitynumber,
	CASE WHEN CHARINDEX(''$ALP$'',activity.ACTIVITYPATH) > 0 THEN REPLACE(activity.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+') ELSE  activity.ACTIVITYPATH END AS ACTIVITYPATH,
	vendor.name vendorname,
	BUDALLOC.costcentername costcenter_name,
	CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INVOICE.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INVOICE.INVOICEPAIDON) ELSE NULL END ELSE NULL END AS QUARTER
	from @REACTIVITY reactivity
	inner join alent_marketingactivity activity on activity.marketingactivityid = reactivity.activity_id
	left outer join @TEOBJECT TEInvoice on TEInvoice.activityid = reactivity.activity_id
	left outer join alent_invoice invoice on TEInvoice.FILTEREDOBJID=invoice.invoiceid
	left outer join @REPLAN REPLAN on REPLAN.FILTEREDOBJID=TEInvoice.FILTEREDOBJID
	left outer join alent_plan plan_alias on REPLAN.PLAN_ID=plan_alias.planid
	LEFT OUTER JOIN @RFBUDGETALLOCATION RFBUDALLOC ON RFBUDALLOC.FILTEREDOBJID=TEInvoice.FILTEREDOBJID  
	LEFT OUTER JOIN ALFCT_BUDGETALLOCATION BUDALLOC ON RFBUDALLOC.BUDALLOC_ID=BUDALLOC.BUDGETALLOCATIONID
	left outer join (select DISTINCT ACTIVITYID,BUSINESSUNIT_ID FROM @REBUSINESSUNIT) rebu on rebu.ACTIVITYID=TEInvoice.ACTIVITYID
	left outer join alent_businessunit bu on rebu.BUSINESSUNIT_ID=bu.businessunitid
	left outer join @RFLINEITEM rflineitem on rflineitem.FILTEREDOBJID=TEInvoice.FILTEREDOBJID
	left outer join alfct_lineitems  lineitems on rflineitem.lineitem_id=lineitems.lineitemsid
	left outer join @REVENDOR revendor on revendor.FILTEREDOBJID=TEInvoice.FILTEREDOBJID
	left outer join alent_vendors vendor on revendor.VEN_ID=vendor.vendorsid
	left outer join @RECOSTCATEGORY recostcat on recostcat.lineitem_id = rflineitem.lineitem_id
	left outer join alent_costcategory costcat on recostcat.costcat_id=costcat.costcategoryid
	'

	Declare @vch10 nvarchar(4000)
	select @vch10 = N' order by invoice.INVOICEPAIDON desc	'

	IF (@errorid = 0)
	BEGIN
		--EXEC (@vch1+@VCHandclause1+@paidondate_clause+@vch2+@VCHandclause2+@paidondate_clause+@vch3+@vch4+@vch5+@vch6+@vch7+@vch8+@vch9+@vch10)

		SELECT @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) +@vch1+@VCHandclause1+@paidondate_clause+@vch2+@VCHandclause2+@paidondate_clause+@vch3+@vch4+@vch5+@vch6+@vch7+@vch8+@vch9+@vch10
		EXEC DBO.SP_EXECUTESQL @final_query
	END

GO

/* Meenal Joshi : DefectID: Defect S1269477*/
ALTER PROCEDURE [DAM_RECALCULATESECTIONCOUNTS]
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
	
	DECLARE @Section_ID bigint, @Section_Path nvarchar(1024);
	DECLARE @Updated_Section_Path nvarchar(4000);
	
	-- Recalculate Section Asset Count	
	UPDATE ALENT_SECTION SET ASSETCOUNTINSECTION = 0,ASSETCOUNTINPATH = 0
	WHERE MARKEDASDELETED = 0;
		
	UPDATE ALENT_SECTION SET ASSETCOUNTINSECTION = A.ASSET_CNT_SEC
	FROM
	ALENT_SECTION SEC1 INNER JOIN (SELECT SEC.SECTIONID AS SEC_ID,COUNT(DIGITALASSETID) AS ASSET_CNT_SEC 
							   FROM 
							   ALENT_DIGITALASSET INNER JOIN ALOM_ASSEMBLY A1
							   ON A1.RELATIONSHIPTYPEID = 94152543310967 AND A1.CONTAINSID = DIGITALASSETID
							   INNER JOIN ALENT_SECTION SEC
							   ON A1.CONTAINERID = SEC.SECTIONID
							   WHERE ALENT_DIGITALASSET.MARKEDASDELETED = 0 AND SEC.MARKEDASDELETED = 0
							   GROUP BY SEC.SECTIONID) A
	ON SEC1.SECTIONID = A.SEC_ID;

    -- Recalculate Section Asset count in Path
	DECLARE Section_Cursor CURSOR FOR 
	SELECT ALENT_SECTION.SECTIONID,ALENT_SECTION.PATH FROM ALENT_SECTION
	WHERE ALENT_SECTION.MARKEDASDELETED = 0;
	
	OPEN Section_Cursor
	FETCH NEXT FROM Section_Cursor 
	INTO @Section_ID, @Section_Path
         
	WHILE @@FETCH_STATUS = 0
	BEGIN
	   
	   --Update _ (underscore) with [_], since _ is a wildcard for LIKE Operator
	   SET @Updated_Section_Path = REPLACE(@Section_Path, '_', '[_]')
	   
	   UPDATE ALENT_SECTION
	   SET ALENT_SECTION.ASSETCOUNTINPATH = (SELECT SUM(SUBSECTION.ASSETCOUNTINSECTION) 
	   FROM ALENT_SECTION SUBSECTION WHERE (((SUBSECTION.PATH LIKE @Updated_Section_Path + '\%') OR (SUBSECTION.SECTIONID = @Section_ID)) 
	   AND SUBSECTION.MARKEDASDELETED = 0))
	   WHERE ALENT_SECTION.SECTIONID = @Section_ID
	   
	   --SET QUERY = ' UPDATE ALENT_SECTION SET ALENT_SECTION.ASSETCOUNTINPATH = (SELECT SUM(SUBSECTION.ASSETCOUNTINSECTION) FROM ALENT_SECTION SUBSECTION WHERE (((SUBSECTION.PATH LIKE ' + @Section_Path + '\%') OR (SUBSECTION.SECTIONID = @Section_ID)) AND SUBSECTION.MARKEDASDELETED = 0)) WHERE ALENT_SECTION.SECTIONID = @Section_ID';
	   FETCH NEXT FROM Section_Cursor 
	   INTO @Section_ID, @Section_Path
	END
	CLOSE Section_Cursor;
	DEALLOCATE Section_Cursor;
    
END

GO

/* Suchitra Bapat : DefectID: S1269197*/
ALTER PROCEDURE [dbo].[RPT_ACTIVITY_BUDGET_SPENDS] @WHERECLAUSEFORPLAN nvarchar(MAX) , @WHERECLAUSEFORACTIVITIES nvarchar(MAX) , 
@WHERECLAUSEFORBUDGETALLOCATION nvarchar(MAX) , @GRPBYTYPE nvarchar(MAX) , @COMMITMENTDETAILSFILTER nvarchar(10) , @FISCAL_YEAR nvarchar(4) , 
@CC_FILTER nvarchar(1) , @WHERECLAUSEFOR_CC nvarchar(MAX)   
   
 AS   DECLARE @errorid1 int,@errorid2 int,@errorid3 int,@errorid4 int,@errorid int,
	@DURATION_TYPE NVARCHAR(10),@MA_TYPE_SEPARATOR NVARCHAR(100),@MA_PATH_SEPARATOR NVARCHAR(100),@final_query nvarchar(max) 

	EXEC @errorid1 = Verify_Input_Where_Clause @WHERECLAUSEFORPLAN
	EXEC @errorid2 = Verify_Input_Where_Clause @WHERECLAUSEFORACTIVITIES
	EXEC @errorid3 = Verify_Input_Where_Clause @WHERECLAUSEFORBUDGETALLOCATION
	EXEC @errorid4 = Verify_Input_Where_Clause @WHERECLAUSEFOR_CC
	SET @errorid = @errorid1+@errorid2+@errorid3+@errorid4

IF (@errorid=0)
BEGIN

					SELECT @DURATION_TYPE = N''
		
			
					IF EXISTS (SELECT 1 FROM ALENT_FORECASTCONFIGURATION WHERE FISCALYEAR = @FISCAL_YEAR)
					BEGIN
						SELECT @DURATION_TYPE = ''''+DURATIONTYPE+'''' FROM ALENT_FORECASTCONFIGURATION WHERE FISCALYEAR = @FISCAL_YEAR
					END
					ELSE
					BEGIN
						SELECT @DURATION_TYPE = N''''+'CALENDAR'+''''
					END
		
					IF EXISTS (SELECT 1 FROM ALENT_CONFIGURATION WHERE CONFIGNAME = 'ACTIVITYTYPESEPARATOR')
					BEGIN
						SELECT @MA_TYPE_SEPARATOR = CONFIGVALUE FROM ALENT_CONFIGURATION WHERE CONFIGNAME = 'ACTIVITYTYPESEPARATOR'
					END
					ELSE
					BEGIN
						SELECT @MA_TYPE_SEPARATOR = N'>>'
					END
		
					IF EXISTS (SELECT 1 FROM ALENT_CONFIGURATION WHERE CONFIGNAME = 'ACTIVITYPATHSEPARATOR')
					BEGIN
						SELECT @MA_PATH_SEPARATOR = CONFIGVALUE FROM ALENT_CONFIGURATION WHERE CONFIGNAME = 'ACTIVITYPATHSEPARATOR'
					END
					ELSE
					BEGIN
						SELECT @MA_PATH_SEPARATOR = N'>>'
					END
	
				IF @CC_FILTER = '0'
				BEGIN
					IF ((@GRPBYTYPE = '0') AND (@COMMITMENTDETAILSFILTER = '0'))
					BEGIN
						SET @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) +N' SELECT DISTINCT TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, 
						ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
						CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
						ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
						CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,
						ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID AS BUDGETALLOCID, ALFCT_BUDGETALLOCATION1.COSTCENTERNAME AS COSTCENTERNAME, 
			
						NULL AS COMMITMENTID, 
						NULL AS COMMITMENT_TITLE, 
						NULL AS COMMITMENT_AMOUNT, 
						NULL AS COMMITMENT_NUMBER, 
						NULL AS INV_NUMBER_FROM_CMT,
			
						INVOICE1.INVOICENUMBER AS INV_NUMBER,
						INVOICE1.INVOICEID AS INVOICE_ID, 
						INVOICE1.TITLE AS INVOICE_TITLE, 
						INVOICE1.STATUS AS INV_STATUS, 
						CASE WHEN INVOICE1.STATUS = ''New'' THEN CAST(ISNULL(INVOICE1.PAIDAMOUNT_A,0) AS FLOAT) WHEN INVOICE1.STATUS =  ''Reconciled'' THEN CAST(ISNULL(INVOICE1.RECONCILEDAMOUNT_A,0) AS FLOAT) ELSE 0 END AS INV_PAID_AMT, INVOICE1.INVOICEPAIDON AS INV_PAID_ON, 
						CAST(INVOICE1.RECONCILEDAMOUNT_A AS FLOAT) AS INV_RECONCILED, 
						INVOICE1.INVOICERECONCILEDON AS INV_RECONCILED_ON,
			
						/*LINEITEMS1.LINEITEMSID AS LINEITEMSID, CC.COSTCATEGORYID AS COSTCAT_ID, 
						FA.FINANCIALACCOUNTID AS FACT_ID,FA.FINANCIALACCOUNTNUMBER AS FACTNO, FA.[NAME] AS FACTNAME, 
						*/
						NULL AS LINEITEMSID, 
						null AS COSTCAT_ID, 
						NULL AS FACT_ID,
						NULL AS FACTNO, 
						NULL AS FACTNAME,
						NULL AS FACT_ID_CMT, 
						NULL AS FACTNO_CMT, 
						NULL AS FACTNAME_CMT, 
			
						NULL AS INVOICE_ID_FROM_CMT, 
						NULL AS INVOICE_TITLE_FROM_CMT, 
						NULL AS INV_STATUS_FROM_CMT, 
						NULL AS INV_PAID_AMT_FROM_CMT, 
						NULL AS INV_PAID_ON_FROM_CMT,
						NULL AS INV_RECONCILED_FROM_CMT, 
						NULL AS INV_RECONCILED_ON_FROM_CMT, 
			
						NULL AS LINEITEMSID_FROM_CMT, 
						NULL AS COSTCAT_ID_FROM_CMT,
			
						CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, CAST(FS.COMMITTED_A AS FLOAT) AS OUSTANDINGCOMMITTED,
						CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INVOICE1.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INVOICE1.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

						FROM
						ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
						ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
						INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

						INNER JOIN ALOM_ASSEMBLY A2 
						ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
						INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
						ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

						INNER JOIN ALOM_ASSOENTITYFACET AEF11 
						ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
						INNER JOIN ALFCT_FINANCIALSUMMARY FS 
						ON AEF11.FACETID = FS.FINANCIALSUMMARYID

						INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
								ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
							N' ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

						INNER JOIN ALOM_ASSEMBLY A1
						ON A1.RELATIONSHIPTYPEID = 258169431586434 AND A1.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID -- 54043127184334
						INNER JOIN ALENT_INVOICE INVOICE1
						ON A1.CONTAINSID = INVOICE1.INVOICEID

						UNION ALL
			
						SELECT 	DISTINCT TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
						CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
						ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
						CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,
						ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID AS BUDGETALLOCID, 
						ALFCT_BUDGETALLOCATION1.COSTCENTERNAME AS COSTCENTERNAME, 
						NULL AS COMMITMENTID, 
						NULL AS COMMITMENT_TITLE, 
						NULL AS COMMITMENT_AMOUNT, 
						NULL AS COMMITMENT_NUMBER, 
						INV_CMT.INVOICENUMBER AS INV_NUMBER_FROM_CMT,
						NULL AS INV_NUMBER,
						NULL AS INVOICE_ID, 
						NULL AS INVOICE_TITLE, 
						NULL AS INV_STATUS, 
						NULL AS INV_PAID_AMT, 
						NULL AS INV_PAID_ON, 
						NULL AS INV_RECONCILED, 
						NULL AS INV_RECONCILED_ON,
						NULL AS LINEITEMSID, 
						NULL AS COSTCAT_ID, 
						NULL AS FACT_ID,NULL AS FACTNO, 
						NULL AS FACTNAME, 

						/* FA_CMT.FINANCIALACCOUNTID AS FACT_ID_CMT, FA_CMT.FINANCIALACCOUNTNUMBER AS FACTNO_CMT, FA_CMT.[NAME] AS FACTNAME_CMT, */
			
						NULL AS FACT_ID_CMT, 
						NULL AS FACTNO_CMT, 
						NULL AS FACTNAME_CMT,
			
						INV_CMT.INVOICEID AS INVOICE_ID_FROM_CMT, 
						INV_CMT.TITLE AS INVOICE_TITLE_FROM_CMT, 
						INV_CMT.STATUS AS INV_STATUS_FROM_CMT,  
						CASE WHEN INV_CMT.STATUS = ''New'' THEN CAST(ISNULL(INV_CMT.PAIDAMOUNT_A,0) AS FLOAT) WHEN INV_CMT.STATUS =  ''Reconciled'' THEN CAST(ISNULL(INV_CMT.RECONCILEDAMOUNT_A,0) AS FLOAT) ELSE 0 END AS INV_PAID_AMT_FROM_CMT, 
						INV_CMT.INVOICEPAIDON AS INV_PAID_ON_FROM_CMT,
						CAST(INV_CMT.RECONCILEDAMOUNT_A AS FLOAT) AS INV_RECONCILED_FROM_CMT, 
						INV_CMT.INVOICERECONCILEDON AS INV_RECONCILED_ON_FROM_CMT, 
			
						/*LINEITEMS_CMT.LINEITEMSID AS LINEITEMSID_FROM_CMT, CC_CMT.COSTCATEGORYID AS COSTCAT_ID_FROM_CMT,*/
			
						NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,

						CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, CAST(FS.COMMITTED_A AS FLOAT) AS OUSTANDINGCOMMITTED,
						CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INV_CMT.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INV_CMT.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

						FROM
						ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
						ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
						INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

						INNER JOIN ALOM_ASSEMBLY A2 
						ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
						INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
						ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

						INNER JOIN ALOM_ASSOENTITYFACET AEF11 
						ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
						INNER JOIN ALFCT_FINANCIALSUMMARY FS 
						ON AEF11.FACETID = FS.FINANCIALSUMMARYID

						INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
								ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
						N'	 ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

						INNER JOIN ALOM_ASSEMBLY A21
						ON A21.RELATIONSHIPTYPEID = 125025473564370 AND A21.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID
						INNER JOIN ALENT_COMMITMENT COMMIT1
						ON A21.CONTAINSID = COMMIT1.COMMITMENTID

						LEFT OUTER JOIN ALOM_ASSEMBLY A22
						ON A22.RELATIONSHIPTYPEID = 107998402773333 AND A22.CONTAINERID = COMMIT1.COMMITMENTID
						LEFT OUTER JOIN ALENT_INVOICE INV_CMT
						ON A22.CONTAINSID = INV_CMT.INVOICEID  '

						EXEC DBO.SP_EXECUTESQL @final_query
					END
					ELSE
					BEGIN
						IF ((@GRPBYTYPE = '0') AND (@COMMITMENTDETAILSFILTER = '1'))
						BEGIN
						SET @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) +N' SELECT DISTINCT TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
							CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
							ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
							CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,
							ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID AS BUDGETALLOCID, ALFCT_BUDGETALLOCATION1.COSTCENTERNAME AS COSTCENTERNAME, 
							NULL AS COMMITMENTID, 
							NULL AS COMMITMENT_TITLE, 
							NULL AS COMMITMENT_AMOUNT, 
							NULL AS COMMITMENT_NUMBER, 
							NULL AS INV_NUMBER_FROM_CMT,
							INVOICE1.INVOICENUMBER AS INV_NUMBER,
							INVOICE1.INVOICEID AS INVOICE_ID, 
							INVOICE1.TITLE AS INVOICE_TITLE, 
							INVOICE1.STATUS AS INV_STATUS, 
							CASE WHEN INVOICE1.STATUS = ''New'' THEN CAST(ISNULL(INVOICE1.PAIDAMOUNT_A,0) AS FLOAT) WHEN INVOICE1.STATUS =  ''Reconciled'' THEN CAST(ISNULL(INVOICE1.RECONCILEDAMOUNT_A,0) AS FLOAT) ELSE 0 END AS INV_PAID_AMT, INVOICE1.INVOICEPAIDON AS INV_PAID_ON, 
							CAST(INVOICE1.RECONCILEDAMOUNT_A AS FLOAT) AS INV_RECONCILED, INVOICE1.INVOICERECONCILEDON AS INV_RECONCILED_ON,
				
							/*LINEITEMS1.LINEITEMSID AS LINEITEMSID, CC.COSTCATEGORYID AS COSTCAT_ID, 
							FA.FINANCIALACCOUNTID AS FACT_ID,FA.FINANCIALACCOUNTNUMBER AS FACTNO, FA.[NAME] AS FACTNAME, */

							NULL AS LINEITEMSID, 
							null AS COSTCAT_ID, 
							NULL AS FACT_ID,
							NULL AS FACTNO, 
							NULL AS FACTNAME,
							NULL AS FACT_ID_CMT, 
							NULL AS FACTNO_CMT, 
							NULL AS FACTNAME_CMT, 
							NULL AS INVOICE_ID_FROM_CMT, 
							NULL AS INVOICE_TITLE_FROM_CMT, 
							NULL AS INV_STATUS_FROM_CMT, 
							NULL AS INV_PAID_AMT_FROM_CMT, 
							NULL AS INV_PAID_ON_FROM_CMT,
							NULL AS INV_RECONCILED_FROM_CMT, 
							NULL AS INV_RECONCILED_ON_FROM_CMT, 
							NULL AS LINEITEMSID_FROM_CMT, 
							NULL AS COSTCAT_ID_FROM_CMT,
							CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, CAST(FS.COMMITTED_A AS FLOAT) AS OUSTANDINGCOMMITTED,
				
							CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INVOICE1.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+N',INVOICE1.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

							FROM

							ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
							ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
							INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

							INNER JOIN ALOM_ASSEMBLY A2 
							ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
							INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
							ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

							INNER JOIN ALOM_ASSOENTITYFACET AEF11 
							ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
							INNER JOIN ALFCT_FINANCIALSUMMARY FS 
							ON AEF11.FACETID = FS.FINANCIALSUMMARYID

							INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
									ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
								N' ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

							INNER JOIN ALOM_ASSEMBLY A1
							ON A1.RELATIONSHIPTYPEID = 258169431586434 AND A1.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID -- 54043127184334
							INNER JOIN ALENT_INVOICE INVOICE1
							ON A1.CONTAINSID = INVOICE1.INVOICEID

							UNION ALL

							SELECT 	DISTINCT	TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
							CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
							ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
							CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,
							ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID AS BUDGETALLOCID, ALFCT_BUDGETALLOCATION1.COSTCENTERNAME AS COSTCENTERNAME, 

							COMMIT1.COMMITMENTID AS COMMITMENTID, 
							COMMIT1.TITLE AS COMMITMENT_TITLE, 
							CAST(COMMIT1.INITIALCOMMITTEDAMOUNT_A AS FLOAT) AS COMMITMENT_AMOUNT, 
							COMMIT1.COMMITMENTNUMBER AS COMMITMENT_NUMBER, 
							INV_CMT.INVOICENUMBER AS INV_NUMBER_FROM_CMT,
							NULL AS INV_NUMBER,
							NULL AS INVOICE_ID, 
							NULL AS INVOICE_TITLE, 
							NULL AS INV_STATUS, 
							NULL AS INV_PAID_AMT, 
							NULL AS INV_PAID_ON, 
							NULL AS INV_RECONCILED, 
							NULL AS INV_RECONCILED_ON,
							NULL AS LINEITEMSID, 
							NULL AS COSTCAT_ID, 
							NULL AS FACT_ID,
							NULL AS FACTNO, 
							NULL AS FACTNAME, 

							/*	FA_CMT.FINANCIALACCOUNTID AS FACT_ID_CMT, FA_CMT.FINANCIALACCOUNTNUMBER AS FACTNO_CMT, FA_CMT.[NAME] AS FACTNAME_CMT, */
				
							NULL AS FACT_ID_CMT, 
							NULL AS FACTNO_CMT, 
							NULL AS FACTNAME_CMT,
							INV_CMT.INVOICEID AS INVOICE_ID_FROM_CMT, 
							INV_CMT.TITLE AS INVOICE_TITLE_FROM_CMT, 
							INV_CMT.STATUS AS INV_STATUS_FROM_CMT, 
							CASE WHEN INV_CMT.STATUS = ''New'' THEN CAST(ISNULL(INV_CMT.PAIDAMOUNT_A,0) AS FLOAT) WHEN INV_CMT.STATUS =  ''Reconciled'' THEN CAST(ISNULL(INV_CMT.RECONCILEDAMOUNT_A,0) AS FLOAT) ELSE 0 END AS INV_PAID_AMT_FROM_CMT, INV_CMT.INVOICEPAIDON AS INV_PAID_ON_FROM_CMT,
							CAST(INV_CMT.RECONCILEDAMOUNT_A AS FLOAT) AS INV_RECONCILED_FROM_CMT, INV_CMT.INVOICERECONCILEDON AS INV_RECONCILED_ON_FROM_CMT, 

							/*LINEITEMS_CMT.LINEITEMSID AS LINEITEMSID_FROM_CMT, CC_CMT.COSTCATEGORYID AS COSTCAT_ID_FROM_CMT,*/
				
							NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
							CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, CAST(FS.COMMITTED_A AS FLOAT) AS OUSTANDINGCOMMITTED,
				
							CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INV_CMT.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INV_CMT.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

							FROM

							ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
							ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
							INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

							INNER JOIN ALOM_ASSEMBLY A2 
							ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
							INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
							ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

							INNER JOIN ALOM_ASSOENTITYFACET AEF11 
							ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
							INNER JOIN ALFCT_FINANCIALSUMMARY FS 
							ON AEF11.FACETID = FS.FINANCIALSUMMARYID

							INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
									ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
							N'	 ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

							INNER JOIN ALOM_ASSEMBLY A21
							ON A21.RELATIONSHIPTYPEID = 125025473564370 AND A21.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID
							INNER JOIN ALENT_COMMITMENT COMMIT1
							ON A21.CONTAINSID = COMMIT1.COMMITMENTID

							LEFT OUTER JOIN ALOM_ASSEMBLY A22
							ON A22.RELATIONSHIPTYPEID = 107998402773333 AND A22.CONTAINERID = COMMIT1.COMMITMENTID
							LEFT OUTER JOIN ALENT_INVOICE INV_CMT
							ON A22.CONTAINSID = INV_CMT.INVOICEID  '

							EXEC DBO.SP_EXECUTESQL @final_query
						END
					END		

					IF ((@GRPBYTYPE = '1') AND (@COMMITMENTDETAILSFILTER = '0'))
					BEGIN
						SET @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) +N' SELECT  DISTINCT TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
						CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
						ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
						CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,

						NULL AS COMMITMENTID, NULL AS COMMITMENT_TITLE, NULL AS COMMITMENT_AMOUNT, NULL AS COMMITMENT_NUMBER, NULL AS INV_NUMBER_FROM_CMT,
						INVOICE1.INVOICENUMBER AS INV_NUMBER,
						INVOICE1.INVOICEID AS INVOICE_ID, INVOICE1.TITLE AS INVOICE_TITLE, INVOICE1.STATUS AS INV_STATUS, 
						CASE WHEN INVOICE1.STATUS = ''New'' THEN CAST(ISNULL(INVOICE1.PAIDAMOUNT_A,0) AS FLOAT) WHEN INVOICE1.STATUS =  ''Reconciled'' THEN CAST(ISNULL(INVOICE1.RECONCILEDAMOUNT_A,0) AS FLOAT) ELSE 0 END AS INV_PAID_AMT, INVOICE1.INVOICEPAIDON AS INV_PAID_ON, 
						CAST(INVOICE1.RECONCILEDAMOUNT_A AS FLOAT) AS INV_RECONCILED, INVOICE1.INVOICERECONCILEDON AS INV_RECONCILED_ON,
						/*LINEITEMS1.LINEITEMSID AS LINEITEMSID, CC.COSTCATEGORYID AS COSTCAT_ID, 
						FA.FINANCIALACCOUNTID AS FACT_ID,FA.FINANCIALACCOUNTNUMBER AS FACTNO, FA.[NAME] AS FACTNAME, */

						NULL AS LINEITEMSID, null AS COSTCAT_ID, 
						NULL AS FACT_ID,NULL AS FACTNO, NULL AS FACTNAME, 

						NULL AS FACT_ID_CMT, NULL AS FACTNO_CMT, NULL AS FACTNAME_CMT, 
						NULL AS INVOICE_ID_FROM_CMT, NULL AS INVOICE_TITLE_FROM_CMT, NULL AS INV_STATUS_FROM_CMT, NULL AS INV_PAID_AMT_FROM_CMT, NULL AS INV_PAID_ON_FROM_CMT,
						NULL AS INV_RECONCILED_FROM_CMT, NULL AS INV_RECONCILED_ON_FROM_CMT, 
						NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
						CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, CAST(FS.COMMITTED_A AS FLOAT) AS OUSTANDINGCOMMITTED,
			
						CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INVOICE1.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INVOICE1.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

						FROM

						ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
						ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
						INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

						INNER JOIN ALOM_ASSEMBLY A2 
						ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
						INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
						ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

						INNER JOIN ALOM_ASSOENTITYFACET AEF11 
						ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
						INNER JOIN ALFCT_FINANCIALSUMMARY FS 
						ON AEF11.FACETID = FS.FINANCIALSUMMARYID

						INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
								ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
							N' ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

						INNER JOIN ALOM_ASSEMBLY A1
						ON A1.RELATIONSHIPTYPEID = 258169431586434 AND A1.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID -- 54043127184334
						INNER JOIN ALENT_INVOICE INVOICE1
						ON A1.CONTAINSID = INVOICE1.INVOICEID

						UNION ALL
			
						SELECT 	DISTINCT	TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
						CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
						ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
						CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,

						NULL AS COMMITMENTID, NULL AS COMMITMENT_TITLE, NULL AS COMMITMENT_AMOUNT, NULL AS COMMITMENT_NUMBER, INV_CMT.INVOICENUMBER AS INV_NUMBER_FROM_CMT,
						NULL AS INV_NUMBER,
						NULL AS INVOICE_ID, NULL AS INVOICE_TITLE, NULL AS INV_STATUS, NULL AS INV_PAID_AMT, NULL AS INV_PAID_ON, 
						NULL AS INV_RECONCILED, NULL AS INV_RECONCILED_ON,
						NULL AS LINEITEMSID, NULL AS COSTCAT_ID, 
						NULL AS FACT_ID,NULL AS FACTNO, NULL AS FACTNAME, 

						/* FA_CMT.FINANCIALACCOUNTID AS FACT_ID_CMT, FA_CMT.FINANCIALACCOUNTNUMBER AS FACTNO_CMT, FA_CMT.[NAME] AS FACTNAME_CMT, */
						NULL AS FACT_ID_CMT, NULL AS FACTNO_CMT, NULL AS FACTNAME_CMT,
						INV_CMT.INVOICEID AS INVOICE_ID_FROM_CMT, INV_CMT.TITLE AS INVOICE_TITLE_FROM_CMT, INV_CMT.STATUS AS INV_STATUS_FROM_CMT, 
						CASE WHEN INV_CMT.STATUS = ''New'' THEN CAST(ISNULL(INV_CMT.PAIDAMOUNT_A,0) AS FLOAT) WHEN INV_CMT.STATUS =  ''Reconciled'' THEN CAST(ISNULL(INV_CMT.RECONCILEDAMOUNT_A,0) AS FLOAT) ELSE 0 END AS INV_PAID_AMT_FROM_CMT, INV_CMT.INVOICEPAIDON AS INV_PAID_ON_FROM_CMT,
						CAST(INV_CMT.RECONCILEDAMOUNT_A AS FLOAT) AS INV_RECONCILED_FROM_CMT, INV_CMT.INVOICERECONCILEDON AS INV_RECONCILED_ON_FROM_CMT, 
						/*LINEITEMS_CMT.LINEITEMSID AS LINEITEMSID_FROM_CMT, CC_CMT.COSTCATEGORYID AS COSTCAT_ID_FROM_CMT,*/
						NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
						CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, CAST(FS.COMMITTED_A AS FLOAT) AS OUSTANDINGCOMMITTED,
			
						CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INV_CMT.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INV_CMT.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

						FROM

						ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
						ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
						INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

						INNER JOIN ALOM_ASSEMBLY A2 
						ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
						INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
						ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

						INNER JOIN ALOM_ASSOENTITYFACET AEF11 
						ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
						INNER JOIN ALFCT_FINANCIALSUMMARY FS 
						ON AEF11.FACETID = FS.FINANCIALSUMMARYID

						INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
								ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
						N'	 ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

						INNER JOIN ALOM_ASSEMBLY A21
						ON A21.RELATIONSHIPTYPEID = 125025473564370 AND A21.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID
						INNER JOIN ALENT_COMMITMENT COMMIT1
						ON A21.CONTAINSID = COMMIT1.COMMITMENTID

						LEFT OUTER JOIN ALOM_ASSEMBLY A22
						ON A22.RELATIONSHIPTYPEID = 107998402773333 AND A22.CONTAINERID = COMMIT1.COMMITMENTID
						LEFT OUTER JOIN ALENT_INVOICE INV_CMT
						ON A22.CONTAINSID = INV_CMT.INVOICEID  '

						EXEC DBO.SP_EXECUTESQL @final_query
					END
					ELSE
					BEGIN
						IF ((@GRPBYTYPE = '1') AND (@COMMITMENTDETAILSFILTER = '1'))
						BEGIN
						SET @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) +N' SELECT DISTINCT TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
							CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
							ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
							CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,

							NULL AS COMMITMENTID, NULL AS COMMITMENT_TITLE, NULL AS COMMITMENT_AMOUNT, NULL AS COMMITMENT_NUMBER, NULL AS INV_NUMBER_FROM_CMT,
							INVOICE1.INVOICENUMBER AS INV_NUMBER,
							INVOICE1.INVOICEID AS INVOICE_ID, INVOICE1.TITLE AS INVOICE_TITLE, INVOICE1.STATUS AS INV_STATUS, 
							CASE WHEN INVOICE1.STATUS = ''New'' THEN CAST(ISNULL(INVOICE1.PAIDAMOUNT_A,0) AS FLOAT) WHEN INVOICE1.STATUS =  ''Reconciled'' THEN CAST(ISNULL(INVOICE1.RECONCILEDAMOUNT_A,0) AS FLOAT) ELSE 0 END AS INV_PAID_AMT, INVOICE1.INVOICEPAIDON AS INV_PAID_ON, 
							CAST(INVOICE1.RECONCILEDAMOUNT_A AS FLOAT) AS INV_RECONCILED, INVOICE1.INVOICERECONCILEDON AS INV_RECONCILED_ON,
							/*LINEITEMS1.LINEITEMSID AS LINEITEMSID, CC.COSTCATEGORYID AS COSTCAT_ID, 
							FA.FINANCIALACCOUNTID AS FACT_ID,FA.FINANCIALACCOUNTNUMBER AS FACTNO, FA.[NAME] AS FACTNAME, */

							NULL AS LINEITEMSID, null AS COSTCAT_ID, 
							NULL AS FACT_ID,NULL AS FACTNO, NULL AS FACTNAME, 

							NULL AS FACT_ID_CMT, NULL AS FACTNO_CMT, NULL AS FACTNAME_CMT, 
							NULL AS INVOICE_ID_FROM_CMT, NULL AS INVOICE_TITLE_FROM_CMT, NULL AS INV_STATUS_FROM_CMT, NULL AS INV_PAID_AMT_FROM_CMT, NULL AS INV_PAID_ON_FROM_CMT,
							NULL AS INV_RECONCILED_FROM_CMT, NULL AS INV_RECONCILED_ON_FROM_CMT, 
							NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
							CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, CAST(FS.COMMITTED_A AS FLOAT) AS OUSTANDINGCOMMITTED,
				
							CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INVOICE1.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INVOICE1.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

							FROM

							ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
							ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
							INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

							INNER JOIN ALOM_ASSEMBLY A2 
							ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
							INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
							ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

							INNER JOIN ALOM_ASSOENTITYFACET AEF11 
							ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
							INNER JOIN ALFCT_FINANCIALSUMMARY FS 
							ON AEF11.FACETID = FS.FINANCIALSUMMARYID

							INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
									ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
								N' ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

							INNER JOIN ALOM_ASSEMBLY A1
							ON A1.RELATIONSHIPTYPEID = 258169431586434 AND A1.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID -- 54043127184334
							INNER JOIN ALENT_INVOICE INVOICE1
							ON A1.CONTAINSID = INVOICE1.INVOICEID

							UNION ALL

							SELECT 	DISTINCT	TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
							CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
							ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
							CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,

							COMMIT1.COMMITMENTID AS COMMITMENTID, COMMIT1.TITLE AS COMMITMENT_TITLE,CAST(COMMIT1.INITIALCOMMITTEDAMOUNT_A AS FLOAT) AS COMMITMENT_AMOUNT, 
								COMMIT1.COMMITMENTNUMBER AS COMMITMENT_NUMBER, INV_CMT.INVOICENUMBER AS INV_NUMBER_FROM_CMT,
							NULL AS INV_NUMBER,
							NULL AS INVOICE_ID, NULL AS INVOICE_TITLE, NULL AS INV_STATUS, NULL AS INV_PAID_AMT, NULL AS INV_PAID_ON, 
							NULL AS INV_RECONCILED, NULL AS INV_RECONCILED_ON,
							NULL AS LINEITEMSID, NULL AS COSTCAT_ID, 
							NULL AS FACT_ID,NULL AS FACTNO, NULL AS FACTNAME, 

							/* FA_CMT.FINANCIALACCOUNTID AS FACT_ID_CMT, FA_CMT.FINANCIALACCOUNTNUMBER AS FACTNO_CMT, FA_CMT.[NAME] AS FACTNAME_CMT, */
							NULL AS FACT_ID_CMT, NULL AS FACTNO_CMT, NULL AS FACTNAME_CMT,
							INV_CMT.INVOICEID AS INVOICE_ID_FROM_CMT, INV_CMT.TITLE AS INVOICE_TITLE_FROM_CMT, INV_CMT.STATUS AS INV_STATUS_FROM_CMT, 
							CASE WHEN INV_CMT.STATUS = ''New'' THEN CAST(ISNULL(INV_CMT.PAIDAMOUNT_A,0) AS FLOAT) WHEN INV_CMT.STATUS =  ''Reconciled'' THEN CAST(ISNULL(INV_CMT.RECONCILEDAMOUNT_A,0) AS FLOAT) ELSE 0 END AS INV_PAID_AMT_FROM_CMT, INV_CMT.INVOICEPAIDON AS INV_PAID_ON_FROM_CMT,
							CAST(INV_CMT.RECONCILEDAMOUNT_A AS FLOAT) AS INV_RECONCILED_FROM_CMT, INV_CMT.INVOICERECONCILEDON AS INV_RECONCILED_ON_FROM_CMT, 
							/*LINEITEMS_CMT.LINEITEMSID AS LINEITEMSID_FROM_CMT, CC_CMT.COSTCATEGORYID AS COSTCAT_ID_FROM_CMT,*/
							NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
							CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, CAST(FS.COMMITTED_A AS FLOAT) AS OUSTANDINGCOMMITTED,
				
							CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INV_CMT.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INV_CMT.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

							FROM

							ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
							ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
							INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+'  

							INNER JOIN ALOM_ASSEMBLY A2 
							ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
							INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
							ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

							INNER JOIN ALOM_ASSOENTITYFACET AEF11 
							ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
							INNER JOIN ALFCT_FINANCIALSUMMARY FS 
							ON AEF11.FACETID = FS.FINANCIALSUMMARYID

							INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
									ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
							N'	 ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+' 

							INNER JOIN ALOM_ASSEMBLY A21
							ON A21.RELATIONSHIPTYPEID = 125025473564370 AND A21.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID
							INNER JOIN ALENT_COMMITMENT COMMIT1
							ON A21.CONTAINSID = COMMIT1.COMMITMENTID

							LEFT OUTER JOIN ALOM_ASSEMBLY A22
							ON A22.RELATIONSHIPTYPEID = 107998402773333 AND A22.CONTAINERID = COMMIT1.COMMITMENTID
							LEFT OUTER JOIN ALENT_INVOICE INV_CMT
							ON A22.CONTAINSID = INV_CMT.INVOICEID   '

							EXEC DBO.SP_EXECUTESQL @final_query
						END
					END
				END
				ELSE
				BEGIN
					IF (@CC_FILTER = '1' AND @GRPBYTYPE <> '2')
					BEGIN
		
							CREATE TABLE #INV_CC_AMT (INVOICE_ID BIGINT, INVOICE_AMT FLOAT)

							EXEC (N' INSERT INTO #INV_CC_AMT (INVOICE_ID,INVOICE_AMT) 
									SELECT INV.INVOICEID,SUM(ISNULL(LITEMS.ITEMAMOUNT_A,0)) 
									FROM ALENT_INVOICE INV INNER JOIN ALOM_ASSOENTITYFACET ASF01
									ON ASF01.RELATIONSHIPTYPEID = 175658777878214 AND ASF01.ENTITYID = INV.INVOICEID
									INNER JOIN ALFCT_LINEITEMS LITEMS
									ON ASF01.FACETID = LITEMS.LINEITEMSID
									INNER JOIN ALOM_ASSOENTITYFACET AEF02
									ON AEF02.RELATIONSHIPTYPEID = 155952577195191 AND AEF02.FACETID = LITEMS.LINEITEMSID
									INNER JOIN ALENT_COSTCATEGORY CC
									ON AEF02.ENTITYID = CC.COSTCATEGORYID   '+@WHERECLAUSEFOR_CC+N'   GROUP BY INV.INVOICEID ')
						
							CREATE TABLE #COMM_CC_AMT (COMMITMENT_ID BIGINT, COMMIT_AMT FLOAT)
				
							EXEC (N' INSERT INTO #COMM_CC_AMT (COMMITMENT_ID,COMMIT_AMT)
									SELECT CMT.COMMITMENTID,SUM(ISNULL(LITEMS.ITEMAMOUNT_A,0))
									FROM
									ALENT_COMMITMENT CMT INNER JOIN ALOM_ASSOENTITYFACET ASF01
									ON ASF01.RELATIONSHIPTYPEID = 25553974373469 AND ASF01.ENTITYID =  CMT.COMMITMENTID
									INNER JOIN ALFCT_LINEITEMS LITEMS
									ON ASF01.FACETID = LITEMS.LINEITEMSID
									INNER JOIN ALOM_ASSOENTITYFACET AEF02
									ON AEF02.RELATIONSHIPTYPEID = 155952577195191 AND AEF02.FACETID = LITEMS.LINEITEMSID
									INNER JOIN ALENT_COSTCATEGORY CC
									ON AEF02.ENTITYID = CC.COSTCATEGORYID   '+@WHERECLAUSEFOR_CC+N'   GROUP BY CMT.COMMITMENTID ') 						
						
							IF ((@GRPBYTYPE = '0') AND (@COMMITMENTDETAILSFILTER = '0'))
							BEGIN
								SET @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) +N' SELECT DISTINCT TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, 
								ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
								CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
								ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
								CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,
								ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID AS BUDGETALLOCID, ALFCT_BUDGETALLOCATION1.COSTCENTERNAME AS COSTCENTERNAME, 
					
								NULL AS COMMITMENTID, 
								NULL AS COMMITMENT_TITLE, 
								NULL AS COMMITMENT_AMOUNT, 
								NULL AS COMMITMENT_NUMBER, 
								NULL AS INV_NUMBER_FROM_CMT,
					
								INVOICE1.INVOICENUMBER AS INV_NUMBER,
								INVOICE1.INVOICEID AS INVOICE_ID, 
								INVOICE1.TITLE AS INVOICE_TITLE, 
								INVOICE1.STATUS AS INV_STATUS, 
								ISNULL(INVOICE_AMT,0)  AS INV_PAID_AMT, INVOICE1.INVOICEPAIDON AS INV_PAID_ON, 
								CASE WHEN INVOICE1.STATUS = ''Reconciled'' THEN ISNULL(INVOICE_AMT,0) ELSE 0 END AS  INV_RECONCILED, 
								INVOICE1.INVOICERECONCILEDON AS INV_RECONCILED_ON,
					
								/*LINEITEMS1.LINEITEMSID AS LINEITEMSID, CC.COSTCATEGORYID AS COSTCAT_ID, 
								FA.FINANCIALACCOUNTID AS FACT_ID,FA.FINANCIALACCOUNTNUMBER AS FACTNO, FA.[NAME] AS FACTNAME, 
								*/
								NULL AS LINEITEMSID, 
								null AS COSTCAT_ID, 
								NULL AS FACT_ID,
								NULL AS FACTNO, 
								NULL AS FACTNAME,
								NULL AS FACT_ID_CMT, 
								NULL AS FACTNO_CMT, 
								NULL AS FACTNAME_CMT, 
					
								NULL AS INVOICE_ID_FROM_CMT, 
								NULL AS INVOICE_TITLE_FROM_CMT, 
								NULL AS INV_STATUS_FROM_CMT, 
								NULL AS INV_PAID_AMT_FROM_CMT, 
								NULL AS INV_PAID_ON_FROM_CMT,
								NULL AS INV_RECONCILED_FROM_CMT, 
								NULL AS INV_RECONCILED_ON_FROM_CMT, 
					
								NULL AS LINEITEMSID_FROM_CMT, 
								NULL AS COSTCAT_ID_FROM_CMT,
					
								CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, CAST(0.0 AS FLOAT) AS OUSTANDINGCOMMITTED,
								CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INVOICE1.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INVOICE1.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

								FROM
								ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
								ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
								INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

								INNER JOIN ALOM_ASSEMBLY A2 
								ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
								INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
								ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

								INNER JOIN ALOM_ASSOENTITYFACET AEF11 
								ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
								INNER JOIN ALFCT_FINANCIALSUMMARY FS 
								ON AEF11.FACETID = FS.FINANCIALSUMMARYID

								INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
										ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
									N' ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

								INNER JOIN ALOM_ASSEMBLY A1
								ON A1.RELATIONSHIPTYPEID = 258169431586434 AND A1.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID -- 54043127184334
								INNER JOIN ALENT_INVOICE INVOICE1
								ON A1.CONTAINSID = INVOICE1.INVOICEID
								INNER JOIN #INV_CC_AMT ON INVOICE1.INVOICEID = INVOICE_ID
					
								UNION ALL
					
								SELECT 	DISTINCT TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
								CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
								ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
								CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,
								ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID AS BUDGETALLOCID, 
								ALFCT_BUDGETALLOCATION1.COSTCENTERNAME AS COSTCENTERNAME, 
								NULL AS COMMITMENTID, 
								NULL AS COMMITMENT_TITLE, 
								NULL AS COMMITMENT_AMOUNT, 
								NULL AS COMMITMENT_NUMBER, 
								INV_CMT.INVOICENUMBER AS INV_NUMBER_FROM_CMT,
								NULL AS INV_NUMBER,
								NULL AS INVOICE_ID, 
								NULL AS INVOICE_TITLE, 
								NULL AS INV_STATUS, 
								NULL AS INV_PAID_AMT, 
								NULL AS INV_PAID_ON, 
								NULL AS INV_RECONCILED, 
								NULL AS INV_RECONCILED_ON,
								NULL AS LINEITEMSID, 
								NULL AS COSTCAT_ID, 
								NULL AS FACT_ID,NULL AS FACTNO, 
								NULL AS FACTNAME, 

								/* FA_CMT.FINANCIALACCOUNTID AS FACT_ID_CMT, FA_CMT.FINANCIALACCOUNTNUMBER AS FACTNO_CMT, FA_CMT.[NAME] AS FACTNAME_CMT, */
					
								NULL AS FACT_ID_CMT, 
								NULL AS FACTNO_CMT, 
								NULL AS FACTNAME_CMT,
					
								INV_CMT.INVOICEID AS INVOICE_ID_FROM_CMT, 
								INV_CMT.TITLE AS INVOICE_TITLE_FROM_CMT, 
								INV_CMT.STATUS AS INV_STATUS_FROM_CMT,  
								ISNULL(INVOICE_AMT,0)  AS INV_PAID_AMT_FROM_CMT, 
								INV_CMT.INVOICEPAIDON AS INV_PAID_ON_FROM_CMT,
								CASE WHEN INV_CMT.STATUS =  ''Reconciled'' THEN ISNULL(INVOICE_AMT,0) ELSE 0 END AS INV_RECONCILED_FROM_CMT, 
								INV_CMT.INVOICERECONCILEDON AS INV_RECONCILED_ON_FROM_CMT, 
					
								/*LINEITEMS_CMT.LINEITEMSID AS LINEITEMSID_FROM_CMT, CC_CMT.COSTCATEGORYID AS COSTCAT_ID_FROM_CMT,*/
					
								NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,

								CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, ISNULL(COMMIT_AMT,0) AS OUSTANDINGCOMMITTED,
								CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INV_CMT.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INV_CMT.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

								FROM
								ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
								ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
								INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

								INNER JOIN ALOM_ASSEMBLY A2 
								ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
								INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
								ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

								INNER JOIN ALOM_ASSOENTITYFACET AEF11 
								ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
								INNER JOIN ALFCT_FINANCIALSUMMARY FS 
								ON AEF11.FACETID = FS.FINANCIALSUMMARYID

								INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
										ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
								N'	 ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

								INNER JOIN ALOM_ASSEMBLY A21
								ON A21.RELATIONSHIPTYPEID = 125025473564370 AND A21.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID
								INNER JOIN ALENT_COMMITMENT COMMIT1
								ON A21.CONTAINSID = COMMIT1.COMMITMENTID
					
								LEFT OUTER JOIN ALOM_ASSEMBLY A22
								ON A22.RELATIONSHIPTYPEID = 107998402773333 AND A22.CONTAINERID = COMMIT1.COMMITMENTID
								LEFT OUTER JOIN ALENT_INVOICE INV_CMT
								ON A22.CONTAINSID = INV_CMT.INVOICEID
					
								LEFT OUTER JOIN #INV_CC_AMT ON INV_CMT.INVOICEID = INVOICE_ID  
								INNER JOIN #COMM_CC_AMT ON COMMIT1.COMMITMENTID = COMMITMENT_ID  '

								EXEC DBO.SP_EXECUTESQL @final_query
							END
							ELSE
							BEGIN
								IF ((@GRPBYTYPE = '0') AND (@COMMITMENTDETAILSFILTER = '1'))
								BEGIN
									SET @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) +N' SELECT DISTINCT TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
									CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
									ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
									CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,
									ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID AS BUDGETALLOCID, ALFCT_BUDGETALLOCATION1.COSTCENTERNAME AS COSTCENTERNAME, 
									NULL AS COMMITMENTID, 
									NULL AS COMMITMENT_TITLE, 
									NULL AS COMMITMENT_AMOUNT, 
									NULL AS COMMITMENT_NUMBER, 
									NULL AS INV_NUMBER_FROM_CMT,
									INVOICE1.INVOICENUMBER AS INV_NUMBER,
									INVOICE1.INVOICEID AS INVOICE_ID, 
									INVOICE1.TITLE AS INVOICE_TITLE, 
									INVOICE1.STATUS AS INV_STATUS, 
									ISNULL(INVOICE_AMT,0)  AS INV_PAID_AMT, INVOICE1.INVOICEPAIDON AS INV_PAID_ON, 
									CASE WHEN INVOICE1.STATUS = ''Reconciled'' THEN ISNULL(INVOICE_AMT,0) ELSE 0 END AS  INV_RECONCILED, 
									INVOICE1.INVOICERECONCILEDON AS INV_RECONCILED_ON,
						
									/*LINEITEMS1.LINEITEMSID AS LINEITEMSID, CC.COSTCATEGORYID AS COSTCAT_ID, 
									FA.FINANCIALACCOUNTID AS FACT_ID,FA.FINANCIALACCOUNTNUMBER AS FACTNO, FA.[NAME] AS FACTNAME, */

									NULL AS LINEITEMSID, 
									null AS COSTCAT_ID, 
									NULL AS FACT_ID,
									NULL AS FACTNO, 
									NULL AS FACTNAME,
									NULL AS FACT_ID_CMT, 
									NULL AS FACTNO_CMT, 
									NULL AS FACTNAME_CMT, 
									NULL AS INVOICE_ID_FROM_CMT, 
									NULL AS INVOICE_TITLE_FROM_CMT, 
									NULL AS INV_STATUS_FROM_CMT, 
									NULL AS INV_PAID_AMT_FROM_CMT, 
									NULL AS INV_PAID_ON_FROM_CMT,
									NULL AS INV_RECONCILED_FROM_CMT, 
									NULL AS INV_RECONCILED_ON_FROM_CMT, 
									NULL AS LINEITEMSID_FROM_CMT, 
									NULL AS COSTCAT_ID_FROM_CMT,
									CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, CAST(0.0 AS FLOAT)  AS OUSTANDINGCOMMITTED,
						
									CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INVOICE1.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INVOICE1.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

									FROM

									ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
									ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
									INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

									INNER JOIN ALOM_ASSEMBLY A2 
									ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
									INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
									ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

									INNER JOIN ALOM_ASSOENTITYFACET AEF11 
									ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
									INNER JOIN ALFCT_FINANCIALSUMMARY FS 
									ON AEF11.FACETID = FS.FINANCIALSUMMARYID

									INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
											ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
										N' ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

									INNER JOIN ALOM_ASSEMBLY A1
									ON A1.RELATIONSHIPTYPEID = 258169431586434 AND A1.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID -- 54043127184334
									INNER JOIN ALENT_INVOICE INVOICE1
									ON A1.CONTAINSID = INVOICE1.INVOICEID
						
									INNER JOIN #INV_CC_AMT ON INVOICE1.INVOICEID = INVOICE_ID
						
									UNION ALL

									SELECT 	DISTINCT	TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
									CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
									ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
									CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,
									ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID AS BUDGETALLOCID, ALFCT_BUDGETALLOCATION1.COSTCENTERNAME AS COSTCENTERNAME, 

									COMMIT1.COMMITMENTID AS COMMITMENTID, 
									COMMIT1.TITLE AS COMMITMENT_TITLE, 
									ISNULL(COMMIT_AMT,0) AS COMMITMENT_AMOUNT, 
									COMMIT1.COMMITMENTNUMBER AS COMMITMENT_NUMBER, 
									INV_CMT.INVOICENUMBER AS INV_NUMBER_FROM_CMT,
									NULL AS INV_NUMBER,
									NULL AS INVOICE_ID, 
									NULL AS INVOICE_TITLE, 
									NULL AS INV_STATUS, 
									NULL AS INV_PAID_AMT, 
									NULL AS INV_PAID_ON, 
									NULL AS INV_RECONCILED, 
									NULL AS INV_RECONCILED_ON,
									NULL AS LINEITEMSID, 
									NULL AS COSTCAT_ID, 
									NULL AS FACT_ID,
									NULL AS FACTNO, 
									NULL AS FACTNAME, 

									/*	FA_CMT.FINANCIALACCOUNTID AS FACT_ID_CMT, FA_CMT.FINANCIALACCOUNTNUMBER AS FACTNO_CMT, FA_CMT.[NAME] AS FACTNAME_CMT, */
						
									NULL AS FACT_ID_CMT, 
									NULL AS FACTNO_CMT, 
									NULL AS FACTNAME_CMT,
									INV_CMT.INVOICEID AS INVOICE_ID_FROM_CMT, 
									INV_CMT.TITLE AS INVOICE_TITLE_FROM_CMT, 
									INV_CMT.STATUS AS INV_STATUS_FROM_CMT, 
									ISNULL(INVOICE_AMT,0)  AS INV_PAID_AMT_FROM_CMT, 
									INV_CMT.INVOICEPAIDON AS INV_PAID_ON_FROM_CMT,
									CASE WHEN INV_CMT.STATUS =  ''Reconciled'' THEN ISNULL(INVOICE_AMT,0) ELSE 0 END AS INV_RECONCILED_FROM_CMT, 
									INV_CMT.INVOICERECONCILEDON AS INV_RECONCILED_ON_FROM_CMT, 

									/*LINEITEMS_CMT.LINEITEMSID AS LINEITEMSID_FROM_CMT, CC_CMT.COSTCATEGORYID AS COSTCAT_ID_FROM_CMT,*/
						
									NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
									CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, ISNULL(COMMIT_AMT,0)  AS OUSTANDINGCOMMITTED,
						
									CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INV_CMT.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INV_CMT.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

									FROM

									ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
									ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
									INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

									INNER JOIN ALOM_ASSEMBLY A2 
									ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
									INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
									ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

									INNER JOIN ALOM_ASSOENTITYFACET AEF11 
									ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
									INNER JOIN ALFCT_FINANCIALSUMMARY FS 
									ON AEF11.FACETID = FS.FINANCIALSUMMARYID

									INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
											ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
									N'	 ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

									INNER JOIN ALOM_ASSEMBLY A21
									ON A21.RELATIONSHIPTYPEID = 125025473564370 AND A21.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID
									INNER JOIN ALENT_COMMITMENT COMMIT1
									ON A21.CONTAINSID = COMMIT1.COMMITMENTID

									LEFT OUTER JOIN ALOM_ASSEMBLY A22
									ON A22.RELATIONSHIPTYPEID = 107998402773333 AND A22.CONTAINERID = COMMIT1.COMMITMENTID
									LEFT OUTER JOIN ALENT_INVOICE INV_CMT
									ON A22.CONTAINSID = INV_CMT.INVOICEID
						
									LEFT OUTER JOIN #INV_CC_AMT ON INV_CMT.INVOICEID = INVOICE_ID  
									INNER JOIN #COMM_CC_AMT ON COMMIT1.COMMITMENTID = COMMITMENT_ID  '

									EXEC DBO.SP_EXECUTESQL @final_query
								END
							END		

							IF ((@GRPBYTYPE = '1') AND (@COMMITMENTDETAILSFILTER = '0'))
							BEGIN
				    
								SET @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) +N' SELECT  DISTINCT TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
								CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
								ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
								CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,

								NULL AS COMMITMENTID, NULL AS COMMITMENT_TITLE, NULL AS COMMITMENT_AMOUNT, NULL AS COMMITMENT_NUMBER, NULL AS INV_NUMBER_FROM_CMT,
								INVOICE1.INVOICENUMBER AS INV_NUMBER,
								INVOICE1.INVOICEID AS INVOICE_ID, INVOICE1.TITLE AS INVOICE_TITLE, INVOICE1.STATUS AS INV_STATUS, 
								ISNULL(INVOICE_AMT,0)   AS INV_PAID_AMT, INVOICE1.INVOICEPAIDON AS INV_PAID_ON, 
								CASE WHEN INVOICE1.STATUS = ''Reconciled'' THEN ISNULL(INVOICE_AMT,0) ELSE 0 END AS  INV_RECONCILED, 
								INVOICE1.INVOICERECONCILEDON AS INV_RECONCILED_ON,
								/*LINEITEMS1.LINEITEMSID AS LINEITEMSID, CC.COSTCATEGORYID AS COSTCAT_ID, 
								FA.FINANCIALACCOUNTID AS FACT_ID,FA.FINANCIALACCOUNTNUMBER AS FACTNO, FA.[NAME] AS FACTNAME, */

								NULL AS LINEITEMSID, null AS COSTCAT_ID, 
								NULL AS FACT_ID,NULL AS FACTNO, NULL AS FACTNAME, 

								NULL AS FACT_ID_CMT, NULL AS FACTNO_CMT, NULL AS FACTNAME_CMT, 
								NULL AS INVOICE_ID_FROM_CMT, NULL AS INVOICE_TITLE_FROM_CMT, NULL AS INV_STATUS_FROM_CMT, NULL AS INV_PAID_AMT_FROM_CMT, NULL AS INV_PAID_ON_FROM_CMT,
								NULL AS INV_RECONCILED_FROM_CMT, NULL AS INV_RECONCILED_ON_FROM_CMT, 
								NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
								CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, CAST(0.0 AS FLOAT)  AS OUSTANDINGCOMMITTED,
					
								CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INVOICE1.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INVOICE1.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

								FROM

								ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
								ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
								INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

								INNER JOIN ALOM_ASSEMBLY A2 
								ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
								INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
								ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

								INNER JOIN ALOM_ASSOENTITYFACET AEF11 
								ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
								INNER JOIN ALFCT_FINANCIALSUMMARY FS 
								ON AEF11.FACETID = FS.FINANCIALSUMMARYID

								INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
										ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
									N' ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

								INNER JOIN ALOM_ASSEMBLY A1
								ON A1.RELATIONSHIPTYPEID = 258169431586434 AND A1.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID -- 54043127184334
								INNER JOIN ALENT_INVOICE INVOICE1
								ON A1.CONTAINSID = INVOICE1.INVOICEID
					
								INNER JOIN #INV_CC_AMT ON INVOICE1.INVOICEID = INVOICE_ID
					
								UNION ALL
					
								SELECT 	DISTINCT	TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
								CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
								ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
								CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,

								NULL AS COMMITMENTID, NULL AS COMMITMENT_TITLE, NULL AS COMMITMENT_AMOUNT, NULL AS COMMITMENT_NUMBER, INV_CMT.INVOICENUMBER AS INV_NUMBER_FROM_CMT,
								NULL AS INV_NUMBER,
								NULL AS INVOICE_ID, NULL AS INVOICE_TITLE, NULL AS INV_STATUS, NULL AS INV_PAID_AMT, NULL AS INV_PAID_ON, 
								NULL AS INV_RECONCILED, NULL AS INV_RECONCILED_ON,
								NULL AS LINEITEMSID, NULL AS COSTCAT_ID, 
								NULL AS FACT_ID,NULL AS FACTNO, NULL AS FACTNAME, 

								/* FA_CMT.FINANCIALACCOUNTID AS FACT_ID_CMT, FA_CMT.FINANCIALACCOUNTNUMBER AS FACTNO_CMT, FA_CMT.[NAME] AS FACTNAME_CMT, */
								NULL AS FACT_ID_CMT, NULL AS FACTNO_CMT, NULL AS FACTNAME_CMT,
								INV_CMT.INVOICEID AS INVOICE_ID_FROM_CMT, INV_CMT.TITLE AS INVOICE_TITLE_FROM_CMT, INV_CMT.STATUS AS INV_STATUS_FROM_CMT, 
								ISNULL(INVOICE_AMT,0)  AS INV_PAID_AMT_FROM_CMT, 
								INV_CMT.INVOICEPAIDON AS INV_PAID_ON_FROM_CMT,
								CASE WHEN INV_CMT.STATUS =  ''Reconciled'' THEN ISNULL(INVOICE_AMT,0) ELSE 0 END AS INV_RECONCILED_FROM_CMT, 
								INV_CMT.INVOICERECONCILEDON AS INV_RECONCILED_ON_FROM_CMT, 
								/*LINEITEMS_CMT.LINEITEMSID AS LINEITEMSID_FROM_CMT, CC_CMT.COSTCATEGORYID AS COSTCAT_ID_FROM_CMT,*/
								NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
								CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, ISNULL(COMMIT_AMT,0)  AS OUSTANDINGCOMMITTED,
					
								CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INV_CMT.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INV_CMT.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

								FROM

								ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
								ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
								INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

								INNER JOIN ALOM_ASSEMBLY A2 
								ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
								INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
								ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

								INNER JOIN ALOM_ASSOENTITYFACET AEF11 
								ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
								INNER JOIN ALFCT_FINANCIALSUMMARY FS 
								ON AEF11.FACETID = FS.FINANCIALSUMMARYID

								INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
										ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
								N'	 ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

								INNER JOIN ALOM_ASSEMBLY A21
								ON A21.RELATIONSHIPTYPEID = 125025473564370 AND A21.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID
								INNER JOIN ALENT_COMMITMENT COMMIT1
								ON A21.CONTAINSID = COMMIT1.COMMITMENTID

								LEFT OUTER JOIN ALOM_ASSEMBLY A22
								ON A22.RELATIONSHIPTYPEID = 107998402773333 AND A22.CONTAINERID = COMMIT1.COMMITMENTID
								LEFT OUTER JOIN ALENT_INVOICE INV_CMT
								ON A22.CONTAINSID = INV_CMT.INVOICEID
					
								LEFT OUTER JOIN #INV_CC_AMT ON INV_CMT.INVOICEID = INVOICE_ID  
								INNER JOIN #COMM_CC_AMT ON COMMIT1.COMMITMENTID = COMMITMENT_ID  '

								EXEC DBO.SP_EXECUTESQL @final_query
							END
							ELSE
							BEGIN
								IF ((@GRPBYTYPE = '1') AND (@COMMITMENTDETAILSFILTER = '1'))
								BEGIN
								SET @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) +N' SELECT DISTINCT TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
									CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
									ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
									CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,

									NULL AS COMMITMENTID, NULL AS COMMITMENT_TITLE, NULL AS COMMITMENT_AMOUNT, NULL AS COMMITMENT_NUMBER, NULL AS INV_NUMBER_FROM_CMT,
									INVOICE1.INVOICENUMBER AS INV_NUMBER,
									INVOICE1.INVOICEID AS INVOICE_ID, INVOICE1.TITLE AS INVOICE_TITLE, INVOICE1.STATUS AS INV_STATUS, 
									ISNULL(INVOICE_AMT,0)   AS INV_PAID_AMT, INVOICE1.INVOICEPAIDON AS INV_PAID_ON, 
									CASE WHEN INVOICE1.STATUS = ''Reconciled'' THEN ISNULL(INVOICE_AMT,0) ELSE 0 END AS  INV_RECONCILED, 
									INVOICE1.INVOICERECONCILEDON AS INV_RECONCILED_ON,
						
									/*LINEITEMS1.LINEITEMSID AS LINEITEMSID, CC.COSTCATEGORYID AS COSTCAT_ID, 
									FA.FINANCIALACCOUNTID AS FACT_ID,FA.FINANCIALACCOUNTNUMBER AS FACTNO, FA.[NAME] AS FACTNAME, */

									NULL AS LINEITEMSID, null AS COSTCAT_ID, 
									NULL AS FACT_ID,NULL AS FACTNO, NULL AS FACTNAME, 

									NULL AS FACT_ID_CMT, NULL AS FACTNO_CMT, NULL AS FACTNAME_CMT, 
									NULL AS INVOICE_ID_FROM_CMT, NULL AS INVOICE_TITLE_FROM_CMT, NULL AS INV_STATUS_FROM_CMT, NULL AS INV_PAID_AMT_FROM_CMT, NULL AS INV_PAID_ON_FROM_CMT,
									NULL AS INV_RECONCILED_FROM_CMT, NULL AS INV_RECONCILED_ON_FROM_CMT, 
									NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
									CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, CAST(0.0 AS FLOAT)  AS OUSTANDINGCOMMITTED,
						
									CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INVOICE1.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INVOICE1.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

									FROM

									ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
									ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
									INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

									INNER JOIN ALOM_ASSEMBLY A2 
									ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
									INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
									ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

									INNER JOIN ALOM_ASSOENTITYFACET AEF11 
									ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
									INNER JOIN ALFCT_FINANCIALSUMMARY FS 
									ON AEF11.FACETID = FS.FINANCIALSUMMARYID

									INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
											ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
										N' ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

									INNER JOIN ALOM_ASSEMBLY A1
									ON A1.RELATIONSHIPTYPEID = 258169431586434 AND A1.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID -- 54043127184334
									INNER JOIN ALENT_INVOICE INVOICE1
									ON A1.CONTAINSID = INVOICE1.INVOICEID
						
									INNER JOIN #INV_CC_AMT ON INVOICE1.INVOICEID = INVOICE_ID
						
									UNION ALL

									SELECT 	DISTINCT	TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
									CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
									ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
									CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,

									COMMIT1.COMMITMENTID AS COMMITMENTID, COMMIT1.TITLE AS COMMITMENT_TITLE,ISNULL(COMMIT_AMT,0) AS COMMITMENT_AMOUNT, 
										COMMIT1.COMMITMENTNUMBER AS COMMITMENT_NUMBER, INV_CMT.INVOICENUMBER AS INV_NUMBER_FROM_CMT,
									NULL AS INV_NUMBER,
									NULL AS INVOICE_ID, NULL AS INVOICE_TITLE, NULL AS INV_STATUS, NULL AS INV_PAID_AMT, NULL AS INV_PAID_ON, 
									NULL AS INV_RECONCILED, NULL AS INV_RECONCILED_ON,
									NULL AS LINEITEMSID, NULL AS COSTCAT_ID, 
									NULL AS FACT_ID,NULL AS FACTNO, NULL AS FACTNAME, 

									/* FA_CMT.FINANCIALACCOUNTID AS FACT_ID_CMT, FA_CMT.FINANCIALACCOUNTNUMBER AS FACTNO_CMT, FA_CMT.[NAME] AS FACTNAME_CMT, */
									NULL AS FACT_ID_CMT, NULL AS FACTNO_CMT, NULL AS FACTNAME_CMT,
									INV_CMT.INVOICEID AS INVOICE_ID_FROM_CMT, INV_CMT.TITLE AS INVOICE_TITLE_FROM_CMT, INV_CMT.STATUS AS INV_STATUS_FROM_CMT, 
									ISNULL(INVOICE_AMT,0) AS INV_PAID_AMT_FROM_CMT, 
									INV_CMT.INVOICEPAIDON AS INV_PAID_ON_FROM_CMT,
									CASE WHEN INV_CMT.STATUS =  ''Reconciled'' THEN ISNULL(INVOICE_AMT,0) ELSE 0 END AS INV_RECONCILED_FROM_CMT, 
									INV_CMT.INVOICERECONCILEDON AS INV_RECONCILED_ON_FROM_CMT, 
									/*LINEITEMS_CMT.LINEITEMSID AS LINEITEMSID_FROM_CMT, CC_CMT.COSTCATEGORYID AS COSTCAT_ID_FROM_CMT,*/
									NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
									CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, ISNULL(COMMIT_AMT,0)  AS OUSTANDINGCOMMITTED,
						
									CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INV_CMT.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INV_CMT.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER

									FROM

									ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
									ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
									INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

									INNER JOIN ALOM_ASSEMBLY A2 
									ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
									INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
									ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

									INNER JOIN ALOM_ASSOENTITYFACET AEF11 
									ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
									INNER JOIN ALFCT_FINANCIALSUMMARY FS 
									ON AEF11.FACETID = FS.FINANCIALSUMMARYID

									INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
											ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
									N'	 ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

									INNER JOIN ALOM_ASSEMBLY A21
									ON A21.RELATIONSHIPTYPEID = 125025473564370 AND A21.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID
									INNER JOIN ALENT_COMMITMENT COMMIT1
									ON A21.CONTAINSID = COMMIT1.COMMITMENTID

									LEFT OUTER JOIN ALOM_ASSEMBLY A22
									ON A22.RELATIONSHIPTYPEID = 107998402773333 AND A22.CONTAINERID = COMMIT1.COMMITMENTID
									LEFT OUTER JOIN ALENT_INVOICE INV_CMT
									ON A22.CONTAINSID = INV_CMT.INVOICEID
						
									LEFT OUTER JOIN #INV_CC_AMT ON INV_CMT.INVOICEID = INVOICE_ID   
									INNER JOIN #COMM_CC_AMT ON COMMIT1.COMMITMENTID = COMMITMENT_ID  '

									EXEC DBO.SP_EXECUTESQL @final_query
								END
							END
					END
				END
	
				-- GROUP BY TYPE = 2 FOR COST CATEGORY
	
				IF @GRPBYTYPE = '2'
				BEGIN
			
						IF @COMMITMENTDETAILSFILTER = '0'
						BEGIN
							SET @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) +N' DECLARE  @COMM_CC_AMT_2 TABLE (COMMITMENT_ID BIGINT,COSTCAT_ID BIGINT,CC_NAME NVARCHAR(150),CC_NUMBER NVARCHAR(100),COMMIT_AMT FLOAT) 
								INSERT INTO @COMM_CC_AMT_2 (COMMITMENT_ID,COSTCAT_ID,CC_NAME,CC_NUMBER,COMMIT_AMT)
								SELECT CMT.COMMITMENTID,CC.COSTCATEGORYID,CC.NAME,CC.COSTCATEGORYNUMBER,SUM(ISNULL(LITEMS.ITEMAMOUNT_A,0))
								FROM
								ALENT_COMMITMENT CMT INNER JOIN ALOM_ASSOENTITYFACET ASF01
								ON ASF01.RELATIONSHIPTYPEID = 25553974373469 AND ASF01.ENTITYID =  CMT.COMMITMENTID
								INNER JOIN ALFCT_LINEITEMS LITEMS
								ON ASF01.FACETID = LITEMS.LINEITEMSID
								INNER JOIN ALOM_ASSOENTITYFACET AEF02
								ON AEF02.RELATIONSHIPTYPEID = 155952577195191 AND AEF02.FACETID = LITEMS.LINEITEMSID
								INNER JOIN ALENT_COSTCATEGORY CC
								ON AEF02.ENTITYID = CC.COSTCATEGORYID   '+@WHERECLAUSEFOR_CC+N'   
								GROUP BY CMT.COMMITMENTID,CC.COSTCATEGORYID,CC.NAME,CC.COSTCATEGORYNUMBER   
					
							SELECT  DISTINCT TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
							CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
							ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
							CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,

							NULL AS COMMITMENTID, NULL AS COMMITMENT_TITLE, NULL AS COMMITMENT_AMOUNT, NULL AS COMMITMENT_NUMBER, NULL AS INV_NUMBER_FROM_CMT,
							INVOICE1.INVOICENUMBER AS INV_NUMBER,
							INVOICE1.INVOICEID AS INVOICE_ID, INVOICE1.TITLE AS INVOICE_TITLE, INVOICE1.STATUS AS INV_STATUS, 
							CAST(ISNULL(LINEITEMS1.ITEMAMOUNT_A,0) AS FLOAT)   AS INV_PAID_AMT, INVOICE1.INVOICEPAIDON AS INV_PAID_ON, 
							CASE WHEN INVOICE1.STATUS =  ''Reconciled'' THEN CAST(ISNULL(LINEITEMS1.ITEMAMOUNT_A,0) AS FLOAT) ELSE 0 END AS INV_RECONCILED, INVOICE1.INVOICERECONCILEDON AS INV_RECONCILED_ON,
							/*LINEITEMS1.LINEITEMSID AS LINEITEMSID, CC.COSTCATEGORYID AS COSTCAT_ID, 
							FA.FINANCIALACCOUNTID AS FACT_ID,FA.FINANCIALACCOUNTNUMBER AS FACTNO, FA.[NAME] AS FACTNAME, */

							NULL AS LINEITEMSID, null AS COSTCAT_ID, 
							NULL AS FACT_ID,NULL AS FACTNO, NULL AS FACTNAME, 

							NULL AS FACT_ID_CMT, NULL AS FACTNO_CMT, NULL AS FACTNAME_CMT, 
							NULL AS INVOICE_ID_FROM_CMT, NULL AS INVOICE_TITLE_FROM_CMT, NULL AS INV_STATUS_FROM_CMT, NULL AS INV_PAID_AMT_FROM_CMT, NULL AS INV_PAID_ON_FROM_CMT,
							NULL AS INV_RECONCILED_FROM_CMT, NULL AS INV_RECONCILED_ON_FROM_CMT, 
							NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
							CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, CAST(0.0 AS FLOAT)  AS OUSTANDINGCOMMITTED,
				
							CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INVOICE1.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INVOICE1.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER,
							CC.NAME AS COSTCATEGORY_NAME,
							CC.COSTCATEGORYNUMBER  AS  COSTCATNO
				
							FROM

							ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
							ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
							INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

							INNER JOIN ALOM_ASSEMBLY A2 
							ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
							INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
							ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

							INNER JOIN ALOM_ASSOENTITYFACET AEF11 
							ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
							INNER JOIN ALFCT_FINANCIALSUMMARY FS 
							ON AEF11.FACETID = FS.FINANCIALSUMMARYID

							INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
									ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
								N' ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 
					
							INNER JOIN ALOM_ASSEMBLY A1
							ON A1.RELATIONSHIPTYPEID = 258169431586434 AND A1.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID -- 54043127184334
							INNER JOIN ALENT_INVOICE INVOICE1
							ON A1.CONTAINSID = INVOICE1.INVOICEID

							INNER JOIN ALOM_ASSOENTITYFACET AEF1
							ON AEF1.RELATIONSHIPTYPEID = 175658777878214 AND AEF1.ENTITYID = INVOICE1.INVOICEID
							INNER JOIN ALFCT_LINEITEMS LINEITEMS1
							ON AEF1.FACETID = LINEITEMS1.LINEITEMSID

							INNER JOIN ALOM_ASSOENTITYFACET AEF2 INNER JOIN ALENT_COSTCATEGORY CC
											ON AEF2.RELATIONSHIPTYPEID = 155952577195191 AND AEF2.ENTITYID = CC.COSTCATEGORYID   '+@WHERECLAUSEFOR_CC+N'  
							ON AEF2.FACETID = LINEITEMS1.LINEITEMSID  
												
							UNION ALL
				
							SELECT 	DISTINCT	TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
							CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
							ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
							CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,

							NULL AS COMMITMENTID, NULL AS COMMITMENT_TITLE, NULL AS COMMITMENT_AMOUNT, NULL AS COMMITMENT_NUMBER, INV_CMT.INVOICENUMBER AS INV_NUMBER_FROM_CMT,
							NULL AS INV_NUMBER,
							NULL AS INVOICE_ID, NULL AS INVOICE_TITLE, NULL AS INV_STATUS, NULL AS INV_PAID_AMT, NULL AS INV_PAID_ON, 
							NULL AS INV_RECONCILED, NULL AS INV_RECONCILED_ON,
							NULL AS LINEITEMSID, NULL AS COSTCAT_ID, 
							NULL AS FACT_ID,NULL AS FACTNO, NULL AS FACTNAME, 

							/* FA_CMT.FINANCIALACCOUNTID AS FACT_ID_CMT, FA_CMT.FINANCIALACCOUNTNUMBER AS FACTNO_CMT, FA_CMT.[NAME] AS FACTNAME_CMT, */
							NULL AS FACT_ID_CMT, NULL AS FACTNO_CMT, NULL AS FACTNAME_CMT,
							INV_CMT.INVOICEID AS INVOICE_ID_FROM_CMT, INV_CMT.TITLE AS INVOICE_TITLE_FROM_CMT, INV_CMT.STATUS AS INV_STATUS_FROM_CMT, 
							CAST(ISNULL(LINEITEMS_CMT.ITEMAMOUNT_A,0) AS FLOAT)  AS INV_PAID_AMT_FROM_CMT, INV_CMT.INVOICEPAIDON AS INV_PAID_ON_FROM_CMT,
							CASE WHEN INV_CMT.STATUS =  ''Reconciled'' THEN CAST(ISNULL(LINEITEMS_CMT.ITEMAMOUNT_A,0) AS FLOAT) ELSE 0 END AS INV_RECONCILED_FROM_CMT, INV_CMT.INVOICERECONCILEDON AS INV_RECONCILED_ON_FROM_CMT, 
							/*LINEITEMS_CMT.LINEITEMSID AS LINEITEMSID_FROM_CMT, CC_CMT.COSTCATEGORYID AS COSTCAT_ID_FROM_CMT,*/
							NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
							CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, ISNULL(CMT_AMT.COMMIT_AMT,0)  AS OUSTANDINGCOMMITTED,
				
							CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INV_CMT.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INV_CMT.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER,
							CC.NAME  AS COSTCATEGORY_NAME,
							CC.COSTCATEGORYNUMBER  AS COSTCATNO
							FROM

							ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
							ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
							INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

							INNER JOIN ALOM_ASSEMBLY A2 
							ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
							INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
							ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

							INNER JOIN ALOM_ASSOENTITYFACET AEF11 
							ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
							INNER JOIN ALFCT_FINANCIALSUMMARY FS 
							ON AEF11.FACETID = FS.FINANCIALSUMMARYID

							INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
									ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
							N'	 ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

							INNER JOIN ALOM_ASSEMBLY A21
							ON A21.RELATIONSHIPTYPEID = 125025473564370 AND A21.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID
							INNER JOIN ALENT_COMMITMENT COMMIT1
							ON A21.CONTAINSID = COMMIT1.COMMITMENTID

							INNER JOIN ALOM_ASSEMBLY A22
							ON A22.RELATIONSHIPTYPEID = 107998402773333 AND A22.CONTAINERID = COMMIT1.COMMITMENTID
							INNER JOIN ALENT_INVOICE INV_CMT
							ON A22.CONTAINSID = INV_CMT.INVOICEID

							INNER JOIN ALOM_ASSOENTITYFACET ASF13
							ON ASF13.RELATIONSHIPTYPEID = 175658777878214 AND ASF13.ENTITYID = INV_CMT.INVOICEID
							INNER JOIN ALFCT_LINEITEMS LINEITEMS_CMT
							ON ASF13.FACETID = LINEITEMS_CMT.LINEITEMSID
				
							INNER JOIN ALOM_ASSOENTITYFACET AEF14 INNER JOIN ALENT_COSTCATEGORY CC
											ON AEF14.RELATIONSHIPTYPEID = 155952577195191 AND AEF14.ENTITYID = CC.COSTCATEGORYID   '+@WHERECLAUSEFOR_CC+N'  
							ON AEF14.FACETID = LINEITEMS_CMT.LINEITEMSID  
				
							LEFT OUTER JOIN @COMM_CC_AMT_2  CMT_AMT ON COMMIT1.COMMITMENTID = CMT_AMT.COMMITMENT_ID  AND CC.COSTCATEGORYID = CMT_AMT.COSTCAT_ID  
				
							UNION ALL
				
							SELECT 	DISTINCT	TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
							CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
							ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
							CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,

							NULL AS COMMITMENTID, NULL AS COMMITMENT_TITLE, NULL AS COMMITMENT_AMOUNT, NULL AS COMMITMENT_NUMBER, NULL AS INV_NUMBER_FROM_CMT,
							NULL AS INV_NUMBER,
							NULL AS INVOICE_ID, NULL AS INVOICE_TITLE, NULL AS INV_STATUS, NULL AS INV_PAID_AMT, NULL AS INV_PAID_ON, 
							NULL AS INV_RECONCILED, NULL AS INV_RECONCILED_ON,
							NULL AS LINEITEMSID, NULL AS COSTCAT_ID, 
							NULL AS FACT_ID,NULL AS FACTNO, NULL AS FACTNAME, 

							/* FA_CMT.FINANCIALACCOUNTID AS FACT_ID_CMT, FA_CMT.FINANCIALACCOUNTNUMBER AS FACTNO_CMT, FA_CMT.[NAME] AS FACTNAME_CMT, */
							NULL AS FACT_ID_CMT, NULL AS FACTNO_CMT, NULL AS FACTNAME_CMT,
							NULL AS INVOICE_ID_FROM_CMT, NULL AS INVOICE_TITLE_FROM_CMT, NULL AS INV_STATUS_FROM_CMT, 
							CAST(0 AS FLOAT)  AS INV_PAID_AMT_FROM_CMT, NULL AS INV_PAID_ON_FROM_CMT,
							CAST(0 AS FLOAT)  AS INV_RECONCILED_FROM_CMT, NULL AS INV_RECONCILED_ON_FROM_CMT, 
							/*LINEITEMS_CMT.LINEITEMSID AS LINEITEMSID_FROM_CMT, CC_CMT.COSTCATEGORYID AS COSTCAT_ID_FROM_CMT,*/
							NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
							CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, ISNULL(CMT_AMT.COMMIT_AMT,0)  AS OUSTANDINGCOMMITTED,
							NULL  AS QUARTER,
							CMT_AMT.CC_NAME    AS COSTCATEGORY_NAME,
							CMT_AMT.CC_NUMBER   AS COSTCATNO
							FROM

							ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
							ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
							INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

							INNER JOIN ALOM_ASSEMBLY A2 
							ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
							INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
							ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

							INNER JOIN ALOM_ASSOENTITYFACET AEF11 
							ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
							INNER JOIN ALFCT_FINANCIALSUMMARY FS 
							ON AEF11.FACETID = FS.FINANCIALSUMMARYID

							INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
									ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
							N'	 ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

							INNER JOIN ALOM_ASSEMBLY A21
							ON A21.RELATIONSHIPTYPEID = 125025473564370 AND A21.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID
							INNER JOIN ALENT_COMMITMENT COMMIT1
							ON A21.CONTAINSID = COMMIT1.COMMITMENTID

							INNER JOIN @COMM_CC_AMT_2 CMT_AMT ON COMMIT1.COMMITMENTID = CMT_AMT.COMMITMENT_ID    
				
							WHERE NOT EXISTS (SELECT 1 FROM ALOM_ASSEMBLY A WHERE A.RELATIONSHIPTYPEID = 107998402773333 AND A.CONTAINERID = COMMIT1.COMMITMENTID	) '
							
							EXEC DBO.SP_EXECUTESQL  @final_query
						END
						ELSE
						BEGIN
							IF @COMMITMENTDETAILSFILTER = '1'
							BEGIN
								SET @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) +N'  DECLARE  @COMM_CC_AMT_2 TABLE (COMMITMENT_ID BIGINT,COSTCAT_ID BIGINT,CC_NAME NVARCHAR(150),CC_NUMBER NVARCHAR(100),COMMIT_AMT FLOAT) 
								INSERT INTO @COMM_CC_AMT_2 (COMMITMENT_ID,COSTCAT_ID,CC_NAME,CC_NUMBER,COMMIT_AMT)
								SELECT CMT.COMMITMENTID,CC.COSTCATEGORYID,CC.NAME,CC.COSTCATEGORYNUMBER,SUM(ISNULL(LITEMS.ITEMAMOUNT_A,0))
								FROM
								ALENT_COMMITMENT CMT INNER JOIN ALOM_ASSOENTITYFACET ASF01
								ON ASF01.RELATIONSHIPTYPEID = 25553974373469 AND ASF01.ENTITYID =  CMT.COMMITMENTID
								INNER JOIN ALFCT_LINEITEMS LITEMS
								ON ASF01.FACETID = LITEMS.LINEITEMSID
								INNER JOIN ALOM_ASSOENTITYFACET AEF02
								ON AEF02.RELATIONSHIPTYPEID = 155952577195191 AND AEF02.FACETID = LITEMS.LINEITEMSID
								INNER JOIN ALENT_COSTCATEGORY CC
								ON AEF02.ENTITYID = CC.COSTCATEGORYID   '+@WHERECLAUSEFOR_CC+N'   
								GROUP BY CMT.COMMITMENTID,CC.COSTCATEGORYID,CC.NAME,CC.COSTCATEGORYNUMBER 
					
								SELECT DISTINCT TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
								CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
								ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
								CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,

								NULL AS COMMITMENTID, NULL AS COMMITMENT_TITLE, NULL AS COMMITMENT_AMOUNT, NULL AS COMMITMENT_NUMBER, NULL AS INV_NUMBER_FROM_CMT,
								INVOICE1.INVOICENUMBER AS INV_NUMBER,
								INVOICE1.INVOICEID AS INVOICE_ID, INVOICE1.TITLE AS INVOICE_TITLE, INVOICE1.STATUS AS INV_STATUS, 
								CAST(ISNULL(LINEITEMS1.ITEMAMOUNT_A,0) AS FLOAT)   AS INV_PAID_AMT, INVOICE1.INVOICEPAIDON AS INV_PAID_ON, 
								CASE WHEN INVOICE1.STATUS =  ''Reconciled'' THEN CAST(LINEITEMS1.ITEMAMOUNT_A AS FLOAT) ELSE 0 END AS INV_RECONCILED, INVOICE1.INVOICERECONCILEDON AS INV_RECONCILED_ON,
								/*LINEITEMS1.LINEITEMSID AS LINEITEMSID, CC.COSTCATEGORYID AS COSTCAT_ID, 
								FA.FINANCIALACCOUNTID AS FACT_ID,FA.FINANCIALACCOUNTNUMBER AS FACTNO, FA.[NAME] AS FACTNAME, */

								NULL AS LINEITEMSID, null AS COSTCAT_ID, 
								NULL AS FACT_ID,NULL AS FACTNO, NULL AS FACTNAME, 

								NULL AS FACT_ID_CMT, NULL AS FACTNO_CMT, NULL AS FACTNAME_CMT, 
								NULL AS INVOICE_ID_FROM_CMT, NULL AS INVOICE_TITLE_FROM_CMT, NULL AS INV_STATUS_FROM_CMT, NULL AS INV_PAID_AMT_FROM_CMT, NULL AS INV_PAID_ON_FROM_CMT,
								NULL AS INV_RECONCILED_FROM_CMT, NULL AS INV_RECONCILED_ON_FROM_CMT, 
								NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
								CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, CAST(0.0 AS FLOAT)  AS OUSTANDINGCOMMITTED,
								CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INVOICE1.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INVOICE1.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER,
								CC.NAME AS COSTCATEGORY_NAME,
								CC.COSTCATEGORYNUMBER  AS  COSTCATNO
					
								FROM
								ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
								ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
								INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

								INNER JOIN ALOM_ASSEMBLY A2 
								ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
								INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
								ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

								INNER JOIN ALOM_ASSOENTITYFACET AEF11 
								ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
								INNER JOIN ALFCT_FINANCIALSUMMARY FS 
								ON AEF11.FACETID = FS.FINANCIALSUMMARYID

								INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
										ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
									N' ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 
						
								INNER JOIN ALOM_ASSEMBLY A1
								ON A1.RELATIONSHIPTYPEID = 258169431586434 AND A1.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID -- 54043127184334
								INNER JOIN ALENT_INVOICE INVOICE1
								ON A1.CONTAINSID = INVOICE1.INVOICEID

								LEFT OUTER JOIN ALOM_ASSOENTITYFACET AEF1
								ON AEF1.RELATIONSHIPTYPEID = 175658777878214 AND AEF1.ENTITYID = INVOICE1.INVOICEID
								LEFT OUTER JOIN ALFCT_LINEITEMS LINEITEMS1
								ON AEF1.FACETID = LINEITEMS1.LINEITEMSID

								INNER JOIN ALOM_ASSOENTITYFACET AEF2 INNER JOIN ALENT_COSTCATEGORY CC
											ON AEF2.RELATIONSHIPTYPEID = 155952577195191 AND AEF2.ENTITYID = CC.COSTCATEGORYID   '+@WHERECLAUSEFOR_CC+N'  
								ON AEF2.FACETID = LINEITEMS1.LINEITEMSID
					
								UNION ALL

								SELECT 	DISTINCT	TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
								CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
								ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
								CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,

								COMMIT1.COMMITMENTID AS COMMITMENTID, COMMIT1.TITLE AS COMMITMENT_TITLE,ISNULL(CMT_AMT.COMMIT_AMT,0) AS COMMITMENT_AMOUNT, 
									COMMIT1.COMMITMENTNUMBER AS COMMITMENT_NUMBER, INV_CMT.INVOICENUMBER AS INV_NUMBER_FROM_CMT,
								NULL AS INV_NUMBER,
								NULL AS INVOICE_ID, NULL AS INVOICE_TITLE, NULL AS INV_STATUS, NULL AS INV_PAID_AMT, NULL AS INV_PAID_ON, 
								NULL AS INV_RECONCILED, NULL AS INV_RECONCILED_ON,
								NULL AS LINEITEMSID, NULL AS COSTCAT_ID, 
								NULL AS FACT_ID,NULL AS FACTNO, NULL AS FACTNAME, 

								/* FA_CMT.FINANCIALACCOUNTID AS FACT_ID_CMT, FA_CMT.FINANCIALACCOUNTNUMBER AS FACTNO_CMT, FA_CMT.[NAME] AS FACTNAME_CMT, */
								NULL AS FACT_ID_CMT, NULL AS FACTNO_CMT, NULL AS FACTNAME_CMT,
								INV_CMT.INVOICEID AS INVOICE_ID_FROM_CMT, INV_CMT.TITLE AS INVOICE_TITLE_FROM_CMT, INV_CMT.STATUS AS INV_STATUS_FROM_CMT, 
								CAST(ISNULL(LINEITEMS_CMT.ITEMAMOUNT_A,0) AS FLOAT)  AS INV_PAID_AMT_FROM_CMT, INV_CMT.INVOICEPAIDON AS INV_PAID_ON_FROM_CMT,
								CASE WHEN INV_CMT.STATUS =  ''Reconciled'' THEN CAST(ISNULL(LINEITEMS_CMT.ITEMAMOUNT_A,0) AS FLOAT) ELSE 0 END AS INV_RECONCILED_FROM_CMT, INV_CMT.INVOICERECONCILEDON AS INV_RECONCILED_ON_FROM_CMT, 
								/*LINEITEMS_CMT.LINEITEMSID AS LINEITEMSID_FROM_CMT, CC_CMT.COSTCATEGORYID AS COSTCAT_ID_FROM_CMT,*/
								NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
								CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, ISNULL(CMT_AMT.COMMIT_AMT,0)  AS OUSTANDINGCOMMITTED,
					
								CASE WHEN '+@DURATION_TYPE+N' = ''PERIOD'' THEN CASE WHEN INV_CMT.INVOICEPAIDON IS NOT NULL THEN DBO.GET_QTR_OF_DATE('+@FISCAL_YEAR+',INV_CMT.INVOICEPAIDON) ELSE NULL END ELSE NULL END  AS QUARTER,
								CC.NAME   AS COSTCATEGORY_NAME,
								CC.COSTCATEGORYNUMBER   AS COSTCATNO
								FROM

								ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
								ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
								INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

								INNER JOIN ALOM_ASSEMBLY A2 
								ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
								INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
								ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

								INNER JOIN ALOM_ASSOENTITYFACET AEF11 
								ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
								INNER JOIN ALFCT_FINANCIALSUMMARY FS 
								ON AEF11.FACETID = FS.FINANCIALSUMMARYID

								INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
										ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
								N'	 ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

								INNER JOIN ALOM_ASSEMBLY A21
								ON A21.RELATIONSHIPTYPEID = 125025473564370 AND A21.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID
								INNER JOIN ALENT_COMMITMENT COMMIT1
								ON A21.CONTAINSID = COMMIT1.COMMITMENTID

								INNER JOIN ALOM_ASSEMBLY A22
								ON A22.RELATIONSHIPTYPEID = 107998402773333 AND A22.CONTAINERID = COMMIT1.COMMITMENTID
								INNER JOIN ALENT_INVOICE INV_CMT
								ON A22.CONTAINSID = INV_CMT.INVOICEID

								INNER JOIN ALOM_ASSOENTITYFACET ASF13
								ON ASF13.RELATIONSHIPTYPEID = 175658777878214 AND ASF13.ENTITYID = INV_CMT.INVOICEID
								INNER JOIN ALFCT_LINEITEMS LINEITEMS_CMT
								ON ASF13.FACETID = LINEITEMS_CMT.LINEITEMSID

								INNER JOIN  ALOM_ASSOENTITYFACET AEF14 INNER JOIN ALENT_COSTCATEGORY CC
											ON AEF14.RELATIONSHIPTYPEID = 155952577195191 AND AEF14.ENTITYID = CC.COSTCATEGORYID   '+@WHERECLAUSEFOR_CC+N'  
								ON AEF14.FACETID = LINEITEMS_CMT.LINEITEMSID  
					
								LEFT OUTER JOIN @COMM_CC_AMT_2 CMT_AMT ON COMMIT1.COMMITMENTID = CMT_AMT.COMMITMENT_ID  AND CC.COSTCATEGORYID = CMT_AMT.COSTCAT_ID
					
								UNION ALL
					
								SELECT 	DISTINCT	TE.PLANID AS PLANID, ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID AS ACTIVITYID, ALENT_MARKETINGACTIVITY_ALIAS.[NAME] AS ACTIVITYNAME,
								CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE,''$ALP$'', '+''''+@MA_TYPE_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYTYPE END AS ACTIVITYTYPE, 
								ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYNUMBER AS ACTNO, 
								CASE WHEN CHARINDEX(''$ALP$'',ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH) > 0 THEN REPLACE(ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH,''$ALP$'', '+''''+@MA_PATH_SEPARATOR+''''+N') ELSE  ALENT_MARKETINGACTIVITY_ALIAS.ACTIVITYPATH END AS ACTIVITYPATH,

								COMMIT1.COMMITMENTID AS COMMITMENTID, COMMIT1.TITLE AS COMMITMENT_TITLE,ISNULL(CMT_AMT.COMMIT_AMT,0) AS COMMITMENT_AMOUNT, 
									COMMIT1.COMMITMENTNUMBER AS COMMITMENT_NUMBER, NULL AS INV_NUMBER_FROM_CMT,
								NULL AS INV_NUMBER,
								NULL AS INVOICE_ID, NULL AS INVOICE_TITLE, NULL AS INV_STATUS, NULL AS INV_PAID_AMT, NULL AS INV_PAID_ON, 
								NULL AS INV_RECONCILED, NULL AS INV_RECONCILED_ON,
								NULL AS LINEITEMSID, NULL AS COSTCAT_ID, 
								NULL AS FACT_ID,NULL AS FACTNO, NULL AS FACTNAME, 

								/* FA_CMT.FINANCIALACCOUNTID AS FACT_ID_CMT, FA_CMT.FINANCIALACCOUNTNUMBER AS FACTNO_CMT, FA_CMT.[NAME] AS FACTNAME_CMT, */
								NULL AS FACT_ID_CMT, NULL AS FACTNO_CMT, NULL AS FACTNAME_CMT,
								NULL AS INVOICE_ID_FROM_CMT, NULL AS INVOICE_TITLE_FROM_CMT, NULL AS INV_STATUS_FROM_CMT, 
								CAST(0 AS FLOAT)  AS INV_PAID_AMT_FROM_CMT, NULL AS INV_PAID_ON_FROM_CMT,
								CAST(0 AS FLOAT)  AS INV_RECONCILED_FROM_CMT, NULL AS INV_RECONCILED_ON_FROM_CMT, 
								/*LINEITEMS_CMT.LINEITEMSID AS LINEITEMSID_FROM_CMT, CC_CMT.COSTCATEGORYID AS COSTCAT_ID_FROM_CMT,*/
								NULL AS LINEITEMSID_FROM_CMT, NULL AS COSTCAT_ID_FROM_CMT,
								CAST(FS.BUDGETED_A AS FLOAT) AS BUDGETED_AMT, CAST(FS.AVAILABLE_A AS FLOAT) AS AVAILABLE, CAST(FS.ALLOCATEDTOSPEND_A AS FLOAT) AS ALLOCATEDTOSPEND, ISNULL(CMT_AMT.COMMIT_AMT,0)  AS OUSTANDINGCOMMITTED,
								NULL  AS QUARTER,
								CMT_AMT.CC_NAME    AS COSTCATEGORY_NAME,
								CMT_AMT.CC_NUMBER   AS COSTCATNO
								FROM

								ALENT_PLAN TE INNER JOIN ALOM_ASSEMBLY A0 
								ON A0.RELATIONSHIPTYPEID = 141014623932230 AND A0.CONTAINERID = TE.PLANID
								INNER JOIN ALENT_BUSINESSUNIT B_UINT_TABLE ON A0.CONTAINSID = B_UINT_TABLE.BUSINESSUNITID  '+@WHERECLAUSEFORPLAN+N'  

								INNER JOIN ALOM_ASSEMBLY A2 
								ON A2.RELATIONSHIPTYPEID IN (38934607864244,198303327217807)  AND A2.CONTAINERID = TE.PLANID
								INNER JOIN ALENT_MARKETINGACTIVITY ALENT_MARKETINGACTIVITY_ALIAS
								ON A2.CONTAINSID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID   

								INNER JOIN ALOM_ASSOENTITYFACET AEF11 
								ON AEF11.RELATIONSHIPTYPEID = 92717298333215 AND AEF11.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID 
								INNER JOIN ALFCT_FINANCIALSUMMARY FS 
								ON AEF11.FACETID = FS.FINANCIALSUMMARYID

								INNER JOIN ALOM_ASSOENTITYFACET ASF12  INNER JOIN ALFCT_BUDGETALLOCATION ALFCT_BUDGETALLOCATION1
										ON  ASF12.RELATIONSHIPTYPEID = 240469225016081 AND ASF12.FACETID = ALFCT_BUDGETALLOCATION1.BUDGETALLOCATIONID  '+@WHERECLAUSEFORBUDGETALLOCATION+
								N'	 ON ASF12.ENTITYID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID '+@WHERECLAUSEFORACTIVITIES+N' 

								INNER JOIN ALOM_ASSEMBLY A21
								ON A21.RELATIONSHIPTYPEID = 125025473564370 AND A21.CONTAINERID = ALENT_MARKETINGACTIVITY_ALIAS.MARKETINGACTIVITYID
								INNER JOIN ALENT_COMMITMENT COMMIT1
								ON A21.CONTAINSID = COMMIT1.COMMITMENTID

								INNER JOIN @COMM_CC_AMT_2 CMT_AMT ON COMMIT1.COMMITMENTID = CMT_AMT.COMMITMENT_ID    
					
								WHERE NOT EXISTS (SELECT 1 FROM ALOM_ASSEMBLY AA WHERE AA.RELATIONSHIPTYPEID = 107998402773333 AND AA.CONTAINERID = COMMIT1.COMMITMENTID ) '

								EXEC DBO.SP_EXECUTESQL @final_query
							END
						END
				END
END

GO
